"use strict";

this.name = "VimanaX_HUD"
this.version = "1.1"
this.author = "Gnievmir, phkb";
this.license = "CC-BY-NC-SA 3.0";
this._sampleList = [];

this._style = "dark";
this._nonLinear = true;
this._ultraZoom = true;
this._AMS = null; // antymissile system
this._SRS = null; // self repair system
this._TLS = null; // telescope
this._TFS = null; // target filtering system
this._SLS = null; // sniper lock        
this._SLP = null; // sniper lock plus       
this._ACH = null; // autocrosshair
this._SEC = null; // shield equalizer-capacitors
this._SC = null;  // Shield Cycler
this._combatMFD = null;
this._LMSS = null; // LMSS
this._specialSlots = [];
this._setSlot1 = 1;
this._setSlot2 = 2;
this._reqFuel = 0;
this._lastUsed = [];
this._hullAnim = [];
this._infoTimer = null;                 //store pointer to text info timer
this._iconTimer = null;                //store pointer to graphical info timer
this._maintenance = false;
this._cbf = null;
this._govs = [];
this._ecos = [];
this._eqDamaged = [];
this._inflightHUD;
this._SC_Armour = false;
this._spacer = "";
this._travelHeader = "";
this._targetHeader = "";
this._checkList = "";
this._shipDamaged = "";
this._shipInfo = "";
this._nextHops = "";
this._debug = false;
this._default = "";
this._killsOnLaunch = 0;
this._timer1Ping = false;
this._timer2Ping = false;
this._timer3Ping = false;
this._widthLookup = 0; // index of the width value in the _widths dictionary 0 = normal, 1 = narrow
this._widths = {
    "VimanaX_ASCName": [9.64, 12.65],
    "VimanaX_SpecialSlot1": [8.9, 11.12],
    "VimanaX_SpecialSlot2": [8.9, 11.12],
    "VimanaX_LaserName": [8.15, 10.38],
    "VimanaX_EQMode": [7.42, 9.64],
    "VimanaX_PSName": [9.74, 10.38],
};

this._gameShips = { // storage; ships and other model picture
    //player ships
    "Python": "python",
    "Boa": "boa",
    "Anaconda": "anaconda",
    "Asp Mark II": "asp2",
    "Adder": "adder",
    "Boa Class Cruiser": "boa_cruiser",
    "Cobra Mark III": "cobra3",
    "Miner Cobra Mark III": "cobra3",
    "Cobra Mark III Miner": "cobra3",
    "Cobra Mark I": "cobra1",
    "Fer-de-Lance": "ferdelance",
    "Moray Star Boat": "moray",
    "Moray Medical Boat": "moray",
    "YellOo Cab": "moray",
    "Griff Boa Prototype": "griff_boa",
    "Wolf Mark II": "wolf2",
    //other ships
    "Griff Krait": "griff_krait",
    "Gecko": "gecko",
    "Green Gecko": "gecko",
    "Krait": "krait",
    "Training Fighter": "krait",
    "Sidewinder Scout Ship": "sidewinder",
    "Mamba": "mamba",
    "Mamba Escort": "mamba",
    "GalCop Viper": "viper",
    "GalCop Viper Interceptor": "interceptor",
    "Transporter": "transporter",
    "Mining Transporter": "transporter",
    "Worm": "worm",
    "Orbital Shuttle": "orbital_shuttle",
    "Constrictor": "constrictor",
    "Thargoid Robot Fighter": "tharglet",
    "Thargoid Warship": "thargoid",
    "Simulator Fighter: Sidewinder": "sidewinder",
    "Simulator Fighter: Sidewinder Escort": "sidewinder",
    "Simulator Fighter: Iron Sidewinder": "sidewinder",
    "Simulator Fighter: Mamba": "mamba",
    "Simulator Fighter: Gecko": "gecko",
    "Simulator Fighter: Krait": "krait",
    "Simulator Fighter: Cobra Mk I": "cobra1",
    "Simulator Fighter: Cobra Mk III": "cobra3",
    "Simulator Fighter: Python": "python",

    "Light Fighter": "light_fighter",
    "GalTech Interceptor": "gt_interceptor",
    "GalTech Escort Fighter": "gt_interceptor",
    "Raider": "raider",
    "Cruzer": "cruzer",
    "Gnat": "gnat",
    "Griffin Mk I": "griffin",
    "Hognose": "hognose",
    "Bug": "bug",
    "Ophidian": "ophidian",
    "Copperhead Mk2": "copperhead",
    "Chopped Cobra": "chopped_cobra",
    "GalCop Cobra Enforcer": "chopped_cobra",
    "Yasen-N": "yasen",
    "Yasen-N 'Advanced'": "yasen",
    "Yasen-N 'Advanced' variant 1": "yasen",
    "Yasen-N 'Advanced' variant 2": "yasen",
    "Yasen-N 'Advanced' variant 3": "yasen",
    "Skat": "skat",
    "Lira": "lira",
    "Vampire Mk VI": "vamkpiremk6",
    "Vampire Mk VI ~ Damage, Inc.": "vampiremk6",
    "King Cobra MkII": "kingcobramk2",
    "KingCobra MkII": "kingcobramk2",
    "KingCobra MkII ~ Damage, Inc.": "kingcobramk2",
    "Arachnid Mark 1": "arachnid",
    "Cobra AC": "cobra_ac",
    "Night Adder": "nightadder",
    "Night Adder Escort": "nightadder",
    "Bushmaster Miner": "bushmaster",
    "Cat Mark II": "cat",
    "Chameleon": "chameleon",
    "Cobra Mark II-X": "cobra2x",
    "Ghavial": "ghavial",
    "Iguana": "iguana",
    "Monitor": "monitor",
    "Monitor Mark II": "monitor2",
    "Mussurana": "mussurana",
    "Asp Mark II Special": "asp2special",
    "Python Class Cruiser": "python_cruiser",
    "Python ET Special": "python_et",
    "Salamander": "salamander",
    "Sidewinder Special": "sidewinder_special",
    "Cobra Mark III-XT": "cobra_xt",
    "Cobra Mk. III-XT 'Black Knave'": "cobra_xt",
    "Qubeenian Rebel Fighter": "krait",
    "Black Baron Minion": "krait",
    "Tourist Ship": "orbital_shuttle",
    "Fer-de-Lance Interceptor": "ferdelance",
    "Krait Patrol": "krait",
    "Adder Miner": "adder",
    "Cobra Mark I Miner": "cobra1",
    "Imperial Quaestor": "viper",
    "Revolutionary Guard": "viper",
    "Imperial Censor": "interceptor",
    "Junta Enforcer": "interceptor",
    "Imperial Lictor": "viper",
    "Aphid": "aphid",
    "Cobra Clipper": "cobra3_clipper",
    "Cobra Clipper SAR": "cobra3_clipper",
    "Cobra Cutlass": "cobra3_cutlass",
    "Cobra Rapier": "cobra3_rapier",
    "Wolf Mark I": "wolf1",
    "RRS Gecko": "gecko",
    "RRS Sidewinder": "sidewinder",
    "RRS Mamba": "mamba",
    "RRS Asp": "asp2",
    "RRS Cobra Mk III": "cobra3",
    "RRS Iguana": "iguana",
    "RRS Salamander": "salamander",
    "RRS Cobra Courier": "cobra3_courier",
    "RRS Cobra Rapier": "cobra3_rapier",
    "RRS Aphid": "aphid",
    "Arafura": "arafura",
    "Viper Raider": "viper_raider",
    "D.T.T. Atlas": "dtt_atlas",
    "D.T.T. Cyclops": "dtt_cyclops",
    "D.T.T. Kraken": "dtt_kraken",
    "D.T.T. MK-1": "dttmk1",
    "DTT Mark I": "dttmk1",
    "D.T.T. Snake Charmer": "dtt_snake_charmer",
    "D.T.T. War Lance": "dtt_war_lance",
    "Chrysopelea MK-I": "chrysopelea",
    "TEC Apep Mk II": "apep2",
    "Sonoran": "sonoran",
    "Eagle Long Range Fighter Mark IV": "adck_eagle_four",
    "Eagle Long Range Fighter Mark I": "adck_eagle_one",
    "Eagle Long Range Fighter Mark III": "adck_eagle_three",
    "Eagle Long Range Fighter Mark II": "adck_eagle_two",
    "Vampire MkIV": "vampiremk4",
    "Vampire MkIV Purgatori": "vampiremk4",
    "Dragonette": "dragonette",
    "Wyrm": "wyrm",
    "Draco": "draco",
    "Urutu Mk III": "urutumk3",
    "Urutu MkIV": "urutumk4",
    "Vampire Mk 1 Gold": "vampiremk1",
    "Vampire Mk I": "vampiremk1",
    "Vampire Purgatori": "vampiremk2",
    "Vampire Mk II": "vampiremk2",
    "Sainsboory's Hauler Anaconda": "anaconda",
    "Oodles Hauler Anaconda": "anaconda",
    "Pi-42 Hauler Anaconda": "anaconda",
    "Tescoo Hauler Anaconda": "anaconda",
    "Mall-Wart Hauler Anaconda": "anaconda",
    "GalaxyMart Hauler Anaconda": "anaconda",
    "Star Hauler Anaconda": "anaconda",
    "Anaconda: Escort Mother": "anaconda",
    "Pi-42 Hauler Boa": "boa",
    "Tescoo Hauler Boa": "boa",
    "Pi-42 Security Sidewinder": "sidewinder",
    "Sainsboory's Security Sidewinder": "sidewinder",
    "Tescoo Security Sidewinder": "sidewinder",
    "Star Security Sidewinder": "sidewinder",
    "Mallwart Security Sidewinder": "sidewinder",
    "Oodles Security Sidewinder": "sidewinder",
    "GalaxyMart Security Sidewinder": "sidewinder",
    "Wolf Mark II (Taranis Corp)": "wolf2",

    "Boa Class Cruiser: Konstantin Katik": "boa_cruiser",
    "Cobra Mark III: Cameron": "cobra3",
    "Cobra Mark III: Greer": "cobra3",
    "Cobra Mark III: Cuervo": "cobra3",
    "Cobra Mark III: Lobo": "cobra3",
    "Cobra Mark III: La Bruja Agent": "cobra3",
    "Cobra Mark III: Zorra": "cobra3",
    "Viper: Bribed Cop": "viper",
    "Rogue Viper": "viper",
    "Rogue Viper Interceptor": "interceptor",
    "Asp Mark II: Katik Escort": "asp2",
    "Asp Mark II: Sahana": "asp2",
    "Katik Python": "python",
    "Katik Escort": "mamba",
    "Katik Anaconda": "anaconda",
    "Mamba: Katik Escort": "mamba",
    "Rogue Escape Pod": "escape",
    "Green Knight": "escape",
    "Asp Mark II Graveship": "asp2",
    "Cobra Mark III Graveship": "cobra3",
    "Boa Class Cruiser Graveship": "boa_cruiser",
    "Moray Star Boat Graveship": "moray",
    "Sidewinder Graveship": "sidewinder",
    "Boa Graveship": "boa",
    "Cobra Mark I Graveship": "cobra1",
    "Anaconda Graveship": "anaconda",
    "Adder Graveship": "adder",
    "Krait Graveship": "krait",
    "Mamba Graveship": "mamba",
    "Moray Graveship": "moray",
    "Gecko Graveship": "gecko",
    "Fer-de-Lance Graveship": "ferdelance",
    "Python Graveship": "python",
    "Python X: Escort Mother": "python_et",
    "Python Cruiser: Escort Mother": "python_cruiser",
    "Python: Escort Mother": "python",
    "Monitor: Escort Mother": "monitor",
    "Boa Mark II: Escort Mother": "boa_cruiser",
    "Boa: Escort Mother": "boa",
    "Ophidian Yacht": "ophidian",
    "Solar Research Ship": "constrictor",
    "Solar Research Ship II": "constrictor",
    "Corona Research Shuttle": "worm",
    "Surface Research Shuttle": "orbital_shuttle",
    "Anaconda Tanker": "anaconda",
    "Tourist Shuttle: The Veiled Mourner": "orbital_shuttle",
    "Separatist Krait": "krait",
    "Separatist Mamba": "mamba",
    "Asp": "asp2",
    "Worm Attack Drone": "worm",
    "Prison Ship": "anaconda",
    "Cobra S9": "chopped_cobra",
    "Cobra Courier": "cobra3_courier",
    "Cobra Courier SE": "cobra3_courier",
    "SuperCobra": "supercobra",
    "Vampire Mark II Purgatori": "vampiremk2",
    "Asp Mark IV": "asp2",
    "Commissar Escape Pod": "escape",
    "Escape capsule (no life signs)": "escape",
    "Jaguar Company Mining Ship": "transporter",
    "Academy Security Patrol": "viper",
    "Academy Security Interceptor": "interceptor",
    "Mega Krait: Augeas Security": "viper",
    "Renegade Phoenix": "phoenix",
    "Salvager Phoenix": "phoenix",
    "Scavenger Phoenix": "phoenix",
    "Cobra Mark IV": "cobra4",
    "Asp Mark I": "asp1",
    "DTT Manta": "dtt_manta",
    "Pitviper": "pitviper1",
    "Pitviper (Bountyhunter)": "pitviper1",
    "Pitviper (Vindicator)": "pitviper1",
    "Pitviper (Buccaneer)": "pitviper1",
    "Pitviper S.E. Beast": "pitviper1",
    "Pitviper Mark II": "pitviper2",
    "Imperial Courier": "impcourier",
    "Purple Haze": "purple_haze",
    "Teretrurus": "purple_haze",
    "Cobra Mark IV Black": "cobra4_black",
    "Drake Mark II": "drake2",
    "Drake": "drake1",
    "Spy Courier": "spy_courier",
    "Holy Avenger Mark II": "blackmonk_gunship",
    "Mine Sweeper Satellite": "blackmonk_minesweeper",
    "Navy Asp Mark II": "navy_asp2",
    "Navy Viper": "navy_viper",
    "Navy Sidewinder": "navy_sidewinder",
    "Navy Thargon Collector": "thargon_collector",
    "Jaguar Company": "jaguar_cobra3",
    "Jaguar Company Splinter Ship": "jaguar_splinter",
    "Nyoka": "wildships_nyoka",
    "Chatu": "wildships_nyoka",
    "Duma": "wildships_duma",
    "Duma Fleet Hauler": "wildships_duma",
    "Imperial Freighter": "freighter",
    "Imperial Tanker": "freighter",
    "Workers' Commuter": "workcom",
    "Orca Worker's Commuter": "workcom",
    "Hacker Viper": "viper",
    "Renegade Viper": "viper",
    "Salvager Hognose": "hognose",
    "Thought Police": "politicop",
    "Taxi Cab": "adder",
    "Secretarybird": "secretarybird",
    "Venom": "venom",
    "Renegade Venom": "venom",
    "Venom ~ Pirate": "venom",
    "Werewolf": "werewolf",
    "Werewolf (Civilian)": "werewolf",
    "Werewolf (Purgatori Model)": "werewolf",
    "Werewolf ~ Damage Inc.": "werewolf",
    "GalCop Dominatrix": "vampiremk3",
    "Reaper Dominatrix": "vampiremk3",
    "Vampire MkIII ~ Purgatori": "vampiremk3",
    "Vampire MkIII ~ Dominatrix": "vampiremk3",
    "Vampire MkIII ~ Dominatrix (Civillian)": "vampiremk3",
    "Vampire MkIII ~ Purgatori (Civillian)": "vampiremk3",
    "Cobra MkB": "cobramkb",
    "Adder Mark III": "adder3",
    "Adder Mark III-E": "adder3",
    "Freiherr-Class Korvette (Aniseres)": "feudal_lord",
    "Freiherr-Class Korvette (Ansois)": "feudal_lord",
    "Freiherr-Class Korvette (Aronar)": "feudal_lord",
    "Freiherr-Class Korvette (Arries)": "feudal_lord",
    "Freiherr-Class Korvette (Atbiarxe)": "feudal_lord",
    "Freiherr-Class Korvette (Atlaar)": "feudal_lord",
    "Freiherr-Class Korvette (Bedierat)": "feudal_lord",
    "Freiherr-Class Korvette (Biarandi)": "feudal_lord",
    "Freiherr-Class Korvette (Ceorat)": "feudal_lord",
    "Freiherr-Class Korvette (Dierlabe)": "feudal_lord",
    "Freiherr-Class Korvette (Digebiti)": "feudal_lord",
    "Freiherr-Class Korvette (Diqudi)": "feudal_lord",
    "Freiherr-Class Korvette (Ededleen)": "feudal_lord",
    "Freiherr-Class Korvette (Edzaon)": "feudal_lord",
    "Freiherr-Class Korvette (Enbirare)": "feudal_lord",
    "Freiherr-Class Korvette (Enlaonus)": "feudal_lord",
    "Freiherr-Class Korvette (Erinain)": "feudal_lord",
    "Freiherr-Class Korvette (Erlaened)": "feudal_lord",
    "Freiherr-Class Korvette (Erxearis)": "feudal_lord",
    "Freiherr-Class Korvette (Esceso)": "feudal_lord",
    "Freiherr-Class Korvette (Esredice)": "feudal_lord",
    "Freiherr-Class Korvette (Essoza)": "feudal_lord",
    "Freiherr-Class Korvette (Geinona)": "feudal_lord",
    "Freiherr-Class Korvette (Gelaed)": "feudal_lord",
    "Freiherr-Class Korvette (Inrearbi)": "feudal_lord",
    "Freiherr-Class Korvette (Israra)": "feudal_lord",
    "Freiherr-Class Korvette (Issoinen)": "feudal_lord",
    "Freiherr-Class Korvette (Mainon)": "feudal_lord",
    "Freiherr-Class Korvette (Mazare)": "feudal_lord",
    "Freiherr-Class Korvette (Oneded)": "feudal_lord",
    "Freiherr-Class Korvette (Onente)": "feudal_lord",
    "Freiherr-Class Korvette (Onertius)": "feudal_lord",
    "Freiherr-Class Korvette (Onusorle)": "feudal_lord",
    "Freiherr-Class Korvette (Oreseren)": "feudal_lord",
    "Freiherr-Class Korvette (Orverace)": "feudal_lord",
    "Freiherr-Class Korvette (Qurexein)": "feudal_lord",
    "Freiherr-Class Korvette (Qutecete)": "feudal_lord",
    "Freiherr-Class Korvette (Rabiarce)": "feudal_lord",
    "Freiherr-Class Korvette (Reenus)": "feudal_lord",
    "Freiherr-Class Korvette (Resoisbe)": "feudal_lord",
    "Freiherr-Class Korvette (Ridivexe)": "feudal_lord",
    "Freiherr-Class Korvette (Rileaa)": "feudal_lord",
    "Freiherr-Class Korvette (Rizace)": "feudal_lord",
    "Freiherr-Class Korvette (Sogeve)": "feudal_lord",
    "Freiherr-Class Korvette (Teususdi)": "feudal_lord",
    "Freiherr-Class Korvette (Tibecea)": "feudal_lord",
    "Freiherr-Class Korvette (Tibedied)": "feudal_lord",
    "Freiherr-Class Korvette (Tiuson)": "feudal_lord",
    "Freiherr-Class Korvette (Usedge)": "feudal_lord",
    "Freiherr-Class Korvette (Usteer)": "feudal_lord",
    "Freiherr-Class Korvette (Zagearbe)": "feudal_lord",
    "Freiherr-Klasse Korvette": "feudal_lord",
    "Prinz Klasse Zerstoerer": "feudal_prince",
    "Prinz-Class Zerstoerer (Aniseres)": "feudal_prince",
    "Prinz-Class Zerstoerer (Ansois)": "feudal_prince",
    "Prinz-Class Zerstoerer (Aronar)": "feudal_prince",
    "Prinz-Class Zerstoerer (Arries)": "feudal_prince",
    "Prinz-Class Zerstoerer (Atbiarxe)": "feudal_prince",
    "Prinz-Class Zerstoerer (Atlaar)": "feudal_prince",
    "Prinz-Class Zerstoerer (Bedierat)": "feudal_prince",
    "Prinz-Class Zerstoerer (Biarandi)": "feudal_prince",
    "Prinz-Class Zerstoerer (Ceorat)": "feudal_prince",
    "Prinz-Class Zerstoerer (Dierlabe)": "feudal_prince",
    "Prinz-Class Zerstoerer (Digebiti)": "feudal_prince",
    "Prinz-Class Zerstoerer (Diqudi)": "feudal_prince",
    "Prinz-Class Zerstoerer (Ededleen)": "feudal_prince",
    "Prinz-Class Zerstoerer (Edzaon)": "feudal_prince",
    "Prinz-Class Zerstoerer (Enbirare)": "feudal_prince",
    "Prinz-Class Zerstoerer (Enlaonus)": "feudal_prince",
    "Prinz-Class Zerstoerer (Erinain)": "feudal_prince",
    "Prinz-Class Zerstoerer (Erlaened)": "feudal_prince",
    "Prinz-Class Zerstoerer (Erxearis)": "feudal_prince",
    "Prinz-Class Zerstoerer (Esceso)": "feudal_prince",
    "Prinz-Class Zerstoerer (Esredice)": "feudal_prince",
    "Prinz-Class Zerstoerer (Geinona)": "feudal_prince",
    "Prinz-Class Zerstoerer (Gelaed)": "feudal_prince",
    "Prinz-Class Zerstoerer (Inrearbi)": "feudal_prince",
    "Prinz-Class Zerstoerer (Israra)": "feudal_prince",
    "Prinz-Class Zerstoerer (Issoinen)": "feudal_prince",
    "Prinz-Class Zerstoerer (Essoza)": "feudal_prince",
    "Prinz-Class Zerstoerer (Mainon)": "feudal_prince",
    "Prinz-Class Zerstoerer (Mazare)": "feudal_prince",
    "Prinz-Class Zerstoerer (Oneded)": "feudal_prince",
    "Prinz-Class Zerstoerer (Onente)": "feudal_prince",
    "Prinz-Class Zerstoerer (Onertius)": "feudal_prince",
    "Prinz-Class Zerstoerer (Onusorle)": "feudal_prince",
    "Prinz-Class Zerstoerer (Oreseren)": "feudal_prince",
    "Prinz-Class Zerstoerer (Orverace)": "feudal_prince",
    "Prinz-Class Zerstoerer (Qurexein)": "feudal_prince",
    "Prinz-Class Zerstoerer (Qutecete)": "feudal_prince",
    "Prinz-Class Zerstoerer (Rabiarce)": "feudal_prince",
    "Prinz-Class Zerstoerer (Reenus)": "feudal_prince",
    "Prinz-Class Zerstoerer (Resoisbe)": "feudal_prince",
    "Prinz-Class Zerstoerer (Ridivexe)": "feudal_prince",
    "Prinz-Class Zerstoerer (Rileaa)": "feudal_prince",
    "Prinz-Class Zerstoerer (Rizace)": "feudal_prince",
    "Prinz-Class Zerstoerer (Sogeve)": "feudal_prince",
    "Prinz-Class Zerstoerer (Teususdi)": "feudal_prince",
    "Prinz-Class Zerstoerer (Tibecea)": "feudal_prince",
    "Prinz-Class Zerstoerer (Tibedied)": "feudal_prince",
    "Prinz-Class Zerstoerer (Tiuson)": "feudal_prince",
    "Prinz-Class Zerstoerer (Usedge)": "feudal_prince",
    "Prinz-Class Zerstoerer (Usteer)": "feudal_prince",
    "Prinz-Class Zerstoerer (Zagearbe)": "feudal_prince",
    "Ritter-Class Jaeger (Aniseres)": "feudal_knight",
    "Ritter-Class Jaeger (Ansois)": "feudal_knight",
    "Ritter-Class Jaeger (Aronar)": "feudal_knight",
    "Ritter-Class Jaeger (Arries)": "feudal_knight",
    "Ritter-Class Jaeger (Atbiarxe)": "feudal_knight",
    "Ritter-Class Jaeger (Atlaar)": "feudal_knight",
    "Ritter-Class Jaeger (Bedierat)": "feudal_knight",
    "Ritter-Class Jaeger (Biarandi)": "feudal_knight",
    "Ritter-Class Jaeger (Ceorat)": "feudal_knight",
    "Ritter-Class Jaeger (Dierlabe)": "feudal_knight",
    "Ritter-Class Jaeger (Digebiti)": "feudal_knight",
    "Ritter-Class Jaeger (Diqudi)": "feudal_knight",
    "Ritter-Class Jaeger (Ededleen)": "feudal_knight",
    "Ritter-Class Jaeger (Edzaon)": "feudal_knight",
    "Ritter-Class Jaeger (Enbirare)": "feudal_knight",
    "Ritter-Class Jaeger (Enlaonus)": "feudal_knight",
    "Ritter-Class Jaeger (Erinain)": "feudal_knight",
    "Ritter-Class Jaeger (Erlaened)": "feudal_knight",
    "Ritter-Class Jaeger (Erxearis)": "feudal_knight",
    "Ritter-Class Jaeger (Esceso)": "feudal_knight",
    "Ritter-Class Jaeger (Esredice)": "feudal_knight",
    "Ritter-Class Jaeger (Essoza)": "feudal_knight",
    "Ritter-Class Jaeger (Geinona)": "feudal_knight",
    "Ritter-Class Jaeger (Gelaed)": "feudal_knight",
    "Ritter-Class Jaeger (Inrearbi)": "feudal_knight",
    "Ritter-Class Jaeger (Israra)": "feudal_knight",
    "Ritter-Class Jaeger (Issoinen)": "feudal_knight",
    "Ritter-Class Jaeger (Mainon)": "feudal_knight",
    "Ritter-Class Jaeger (Mazare)": "feudal_knight",
    "Ritter-Class Jaeger (Oneded)": "feudal_knight",
    "Ritter-Class Jaeger (Onente)": "feudal_knight",
    "Ritter-Class Jaeger (Onertius)": "feudal_knight",
    "Ritter-Class Jaeger (Onusorle)": "feudal_knight",
    "Ritter-Class Jaeger (Oreseren)": "feudal_knight",
    "Ritter-Class Jaeger (Orverace)": "feudal_knight",
    "Ritter-Class Jaeger (Qurexein)": "feudal_knight",
    "Ritter-Class Jaeger (Qutecete)": "feudal_knight",
    "Ritter-Class Jaeger (Rabiarce)": "feudal_knight",
    "Ritter-Class Jaeger (Reenus)": "feudal_knight",
    "Ritter-Class Jaeger (Resoisbe)": "feudal_knight",
    "Ritter-Class Jaeger (Ridivexe)": "feudal_knight",
    "Ritter-Class Jaeger (Rileaa)": "feudal_knight",
    "Ritter-Class Jaeger (Rizace)": "feudal_knight",
    "Ritter-Class Jaeger (Sogeve)": "feudal_knight",
    "Ritter-Class Jaeger (Teususdi)": "feudal_knight",
    "Ritter-Class Jaeger (Tibecea)": "feudal_knight",
    "Ritter-Class Jaeger (Tibedied)": "feudal_knight",
    "Ritter-Class Jaeger (Tiuson)": "feudal_knight",
    "Ritter-Class Jaeger (Usedge)": "feudal_knight",
    "Ritter-Class Jaeger (Usteer)": "feudal_knight",
    "Ritter-Class Jaeger (Zagearbe)": "feudal_knight",
    "Ritter-Klasse Jaeger": "feudal_knight",
    "Feudal Freighter": "***",
    "Asp MkII": "asp2",
    "Orisis class Ferry": "orisis_ferry",
    "Jade Class RunAbout": "orbital_shuttle",
    "Diamond Class Shuttle": "orbital_shuttle",
    "Trident Executive Shuttle": "trident",
    "Strelka Cruiseliner": "strelka",
    "StarSeeker Personal Shuttle": "starseeker",
    "Delta Long-Range Escort": "delta",
    "Gemini Escort": "gemini",
    "Armoured Transport Type1": "att1",
    "D.T.T. Galaxy Liner": "dtt_galaxy_liner",
    "DTT Wraith": "dtt_wraith",
    "D.T.T. Heart of Gold": "dtt_heart_of_gold",
    "D.T.T. Planet Express": "dtt_planet_express",
    "DTT Tomahawk": "dtt_tomahawk",
    "Eagle Escort": "eagle_escort",
    "Hornet": "hornet",
    "Krait Explorer": "krait",
    "Mamba Explorer": "mamba",
    "Imperial Navy Asp Mark II": "asp2",
    "Imperial Navy Sidewinder": "sidewinder",
    "Imperial Navy Anaconda": "anaconda",
    "Imperial Navy Boa Class Cruiser": "boa_cruiser",
    "Imperial Navy Constrictor": "constrictor",
    "Navy Intelligence Constrictor": "constrictor",
    "Navy Special Ops Asp Mark II": "asp2",
    "Barracuda: Security Patrol": "barracuda",
    "Renegade Barracuda": "barracuda",
    "Barracuda": "barracuda",
    "Police Barracuda": "barracuda",
    "Shark": "shark",
    "Shark Escort": "shark",
    "Orca Class Destroyer": "aquatics_destroyer",
    "Orca Class Destroyer (Hijacked)": "aquatics_destroyer",
    "GalCop Manta Ray": "mantaray",
    "Manta: Security Patrol": "mantaray",
    "Manta Ray": "mantaray",
    "Military Manta Ray": "mantaray",
    "Fugu Tanker": "fugu",
    "Guardian Drone": "aquatics_guardian",
    "HammerHead Hauler Carrier": "hammerhead",
    "Hawksbill Fuel Tanker": "hawksbill",
    "AHC Kraken IV (Hijacked)": "kraken",
    "Man O' War": "manowar",
    "Fuel Frame": "fuelframe",
    "Box Escort": "box_escort",
    "Ionics Redback": "redback",
    "RLF Leader": "redback",
    "Ramazan Government Redback": "redback",
    "Ramazan Government Whitetail": "whitetail",
    "Ionics Whitetail": "whitetail",
    "RLF Fighter": "whitetail",
    "Ionics Funnelweb": "funnelweb",
    "Ionics Huntsman": "huntsman",
    "Link Vessel": "huntsman",
    "RLF Vessel": "huntsman",
    "Reserve Cobra Mark III": "cobra3",
    "Reserve Cobra Mark I": "cobra1",
    "Reserve Asp Mark II": "asp2",
    "Navy Medical Ship": "seccom_medship",
    "Thargoid Battleship": "thargbatship",
    "Thargoid Cruiser": "thargcruiser",
    "Thargoid Invader": "galnav_thargoid",
    "Headhunter": "krait",
    "Navy Landing Craft": "navy_lander",
    "Navy Shuttle": "navy_shuttle",
    "Navy Transport": "navy_transport",
    "Navy Frigate": "picket_frigate",
    "Navy Minesweeper Mk II": "minesweeper",
    "Pirate Frigate": "picket_frigate",
    "Rogue Frigate": "picket_frigate",
    "Chimera Gunship": "chimera",
    "Serpent Class Cruiser": "serpent_cruiser",
    "Andromeda": "andromeda",
    "Gecko: Triad Henchman": "gecko",
    "Gecko: Triad Goon": "gecko",
    "Mega Mamba: Crazy 88": "mamba",
    "Mega Mamba: Soin Clan Sister": "mamba",
    "Mega Fer-de-Lance: Inno Soin": "ferdelance",
    "Anaconda: Mafia Narcotics Transport": "anaconda",
    "Boa Class Cruiser : Systems Shutdown": "boa_cruiser",
    "Fer-de-Lance : Systems Shutdown": "ferdelance",
    "Asp Mark II : Systems Shutdown": "asp2",
    "Adder : Systems Shutdown": "adder",
    "Repair Crew Transporter: Cat Nap": "transporter",
    "Krait Interceptor: Augeas Security": "krait",
    "Vintage Adder": "vintageadder",
    "Vintage Adder: The Sitting Duck": "vintageadder",
    "Guild Target : Hockey Team - 5,000C": "armoured_transport",
    "Guild Target : The Fair Wind - 30,000C": "anaconda",
    "Armoured Passenger Transport": "armoured_transport",
    "Guild Target : Inspector Thorstan - 40,000C": "asp2",
    "Guild Target : Control Drone - 60,000C": "navydrone",
    "Hooded Cobra: O-Ren Ishii": "hoodedcobra",
    "Guild Target : Boss Yankisona - 70,000C": "excalibur",
    "PTSF 200-X3: Triad Bodyguard": "excalibur",
    "Guild Target : GSS Indefatigable - 80,000C": "aeron",
    "Cobra III NjX": "cobra3njx",
    "Cobra III NjX: Rebel Fighter": "cobra3njx",
    "Nemesis Mark I: Team Minder": "nemesis1",
    "Nemesis Mark I: Irate Hockey Fan": "nemesis1",
    "Nemesis Mark I": "nemesis1",
    "Guild Target : Balrog Dreadnaught - 90,000C": "balrog",
    "Eszausveian Navy : Balrog Class Dreadnaught": "balrog",
    "Daemon Class Cruiser": "daemon_cruiser",
    "Daemon Class Cruiser: Eszausveian Navy": "daemon_cruiser",
    "Guild Target : ESS Defiant - 100,000C": "daemon_cruiser",
    "Mongoose Fighter": "mongoose",
    "Mongoose: Eszausveian Navy": "mongoose",
    "Scorpion Frigate": "scorpion",
    "Scorpion Frigate: Eszausveian Navy": "scorpion",
    "Wasp EX-01: Triad Enforcer": "wasp",
    "Wasp EX-01: Triad Hitman": "wasp",
    "Wasp EX-01: Triad Liquidator": "wasp",
    "Navy BattleBot Mark I": "navybattlebot1",
    "Malfunctioning BattleBot": "navybattlebot1",
    "Navy BattleBot Mark II": "navybattlebot2",
    "BattleBot Control Drone": "navydrone",
    "Wiseguy Sidewinder": "sidewinder",
    "Mobile Mine Sweeper Satellite": "blackmonk_minesweeper",
    "Thargoid Deathwreaker": "newbug1",
    "Plasma Sentry Drone": "plasmadrone",
    "Aeron Class Frigate": "aeron",
    "Aeron Class Frigate: Rebel Fleet": "aeron",
    "249Alpha Active Wing": "cobra3",
    "249Alpha Reserve Wing": "cobra3",
    "249Alpha Reserve Escort": "cobra3",
    "249Alpha Active Wingman": "cobra3",
    "249Alpha Reserve Cruiser": "anaconda",
    "249Alpha Active Cruiser": "anaconda",
    "Stealth Barracuda Escort": "barracuda",
    "Stealth Barracuda (hunter)": "barracuda",
    "Stealth Barracuda (hunter-hard)": "barracuda",
    "Stealth Barracuda (courier)": "barracuda",
    "Stealth Barracuda (Stolen)": "barracuda",
    "Stealth Barracuda (raider)": "barracuda",
    "Stealth Barracuda (raider-hard)": "barracuda",
    "Stealth Barracuda (assassin)": "barracuda",
    "Stealth (raider-heavy)": "bellatrix",
    "Stealth (hunter-heavy)": "bellatrix",
    "Stealth Bellatrix Cruiser": "bellatrix",
    "Whiskey Runner": "asp2",
    "Baakili Far Trader": "baakili",
    "Kirin Military Transport": "kirin_xm",
    "Kirin XM": "kirin_xm",
    "Kirin Sport": "kirin_sport",
    "\"Red Knights Squadron\" Viper": "viper",
    "Excalibur": "excalibur",
    "Condor": "condor",
    "NavyCondor": "condor_navy",
    "PoliceCondor": "condor_police",
    "SwatCondor": "condor_swat",
    "Cougar": "cougar",
    "Cougar ST": "cougar_st",
    "Falcon": "falcon",
    "Falcon-E": "falcon",
    "Falcon-H": "falcon",
    "Falcon-S": "falcon",
    "Falcon-T": "falcon",
    "Constitution Class Heavy Cruiser": "constitution",
    "Merlin": "merlin",
    "Kestrel": "kestrel",
    "KestrelInterceptor": "kestrel",
    "PoliceKestrel": "kestrel",
    "Maelstrom": "maelstrom",
    "Vortex": "vortex",
    "Veloce e Appuntita": "veloceeappuntita",
    "GalCop Veloce e Appuntita": "veloceeappuntita",
    "Veloce e Appuntita S": "veloceeappuntita",
    "Sidewinder-X": "sidewinder_x",
    "Cobra2-X": "cobra2_x",
    "Cobra2-C": "cobra2_x",
    "Asp-X": "asp_x",
    "TAU Rockhopper": "taurockhopper",
    "GRS Shuttle": "orbital_shuttle",
    "GRS Armadillo": "buoytugger",
    "GRS Guanako": "guanako",
    "GRS Controller": "grs_controller",
    "Inter-system ferry": "anaconda",
    "Stormbrewer": "stormbrewer",
    "Stormbrewer Vigilante": "stormbrewer",
    "SKS Plasma Mark I": "sks_plasma1",
    "Fer-de-Lance Lightspeeder": "fdl_lightspeeder",
    "Star Destroyer": "stardestroyer",
    "Black Star Destroyer": "stardestroyer",
    "Imperial Star Destroyer": "stardestroyer",
    "Star Destroyer [reactor breach detected]": "stardestroyer",
    "Imperial Shuttle": "stardestroyershuttle",
    "TIE Fighter": "tiefighter",
    "TIE Interceptor": "tieinterceptor",
    "Saiph Interceptor": "saiph",
    "Rigel Tactical Bomber": "rigel",
    "Long Range Cruiser": "long_range_cruiser",
    "Bellatrix Cruiser": "bellatrix",
    "Lynx Bulk Carrier": "lynx",
    "Lynx Bulk Carrier - No Trailer": "lynx_nocar",
    "Bulk Hauler": "bulk_hauler",
    "Bulk Hauler - Eldjotnar": "bulk_hauler",
    "Bulk Hauler - Muninn": "bulk_hauler",
    "Bulk Hauler - Jormundgand": "bulk_hauler",
    "Bulk Hauler - Fenrir": "bulk_hauler",
    "Decomissioned Bulk Hauler": "bulk_hauler",
    "Super Bulk Hauler": "super_bulk_hauler",
    "Heavy Metal S": "heavy_metal_s",
    "Heavy Metal S Freight Hauler": "heavy_metal_s",
    "Heavy Metal D": "heavy_metal_d",
    "Heavy Metal D Freight Hauler": "heavy_metal_d",
    "Phantom": "phantom",
    "Phantom Intimidator": "phantom_intimidator",
    "Vampire MkV ~ Spectre": "vampiremk5",
    "Draven Carrier": "draven_carrier",
    "Draven Gunship": "draven_gunship",
    "Draven_Gunship": "draven_gunship",
    "Draven_Raider": "draven_raider",
    "Draven Trader": "draven_trader",
    "Draven_Trader": "draven_trader",
    "Draven Shuttle": "draven_shuttle",
    "Kracken": "kracken",

    //other targets
    "Cargo container": "cargo",
    "Escape capsule": "escape",
    "Escape Capsule": "escape",
    "Ejected Pilot": "pilot",
    "Thargoid Spy Satellite": "thargon_sat",
    "Asteroid": "asteroid",
    "Boulder": "boulder",
    "Splinter": "splinter",
    "Fragment": "fragment",
    "Training Asteroid": "asteroid",
    "Sentinel Asteroid": "sentinel_asteroid",
    "UPS container": "cargo",
    "Escape Capsule: Asp Pilot": "escape",
    "Escape Capsule: Sahana": "escape",
    "Escape Capsule: Greer": "escape",
    "Escape Capsule: Konstantin Katik": "escape",
    "GalTech escape pod GIC-E1": "galtech_escape1",
    "GalTech escape pod GIC-E2": "galtech_escape2",
    "Broadcast Array Navbouy": "broadcast_array_beacon",
    "Black Box": "black_box",
    "King Cobra Escape Capsule": "kc2escape",
    "Grave Monument (Mark of Chaos)": "tgy_chaos",
    "Grave Monument (Latin Crucifix)": "tgy_cross1",
    "Grave Monument (Pointed Crucifix)": "tgy_cross2",
    "Grave Monument (Star of David)": "tgy_david",
    "Grave Monument (Infinity)": "tgy_infinity",
    "Grave Monument (Wooden Crucifix)": "tgy_latincross",
    "Grave Monument (Mjolnir)": "tgy_mjolnir",
    "Grave Monument (Moai)": "tgy_moai",
    "Grave Monument (Pentagram)": "tgy_pentagon",
    "Graveyard Stone": "tgy_rip",
    "Graveyard Monument": "tgy_octagon",
    "Graveyard Beacon": "tgy_beacon",
    "Tomb Casket": "tgy_mausoleum",
    "Ironfist Memorial": "memorial_ironfist",
    "Svengali Memorial": "memorial_ironfist",
    "Ground Radar": "slave_satellite",
    "GalMine Hopper": "mining_hopper",
    "Sentinel Satellite": "blackmonk_minesweeper",
    "GalMine AutoMiner": "autominer",
    "Escaped Convict": "escapee1",
    "Mining Pod: Escaped Convict": "escapee1",
    "Mining Pod: Astromine Convict": "escapee1",
    "Target Drone": "escape",
    "escape capsule": "escape",
    "Lifeboat": "escape",
    "Surveillance Satellite": "rssatellite_1",
    "COMLR Satellite": "rssatellite_2",
    "COM Satellite": "rssatellite_3",
    "Satellite Telescope": "rssatellite_4",
    "Attack Drone": "liners_drone",
    "Stellar Serpent": "serpent",
    "Female Star-Jelly": "starjelly1",
    "Male Star-Jelly": "starjelly2",
    "Star-Jelly egg": "starjellyegg",
    "Star-Jelly larva": "starjellylarva",
    "Error: Entry in the wrong role!": "tgy_rip",
    "Transmitter": "cotbs_transmitter",
    "Fragmentation Bomb": "rmb_mine_launcher",
    "Remote Launcher": "rmb_mine_launcher",
    "Distress Beacon Launcher": "rmb_mine_launcher",
    "Chaff Launcher": "rmb_mine_launcher",
    "Defence Missile Launcher": "rmb_mine_launcher",
    "Remote Detonation Mine": "rmb_mine",
    "Anti-Thargoid Warhead": "rmb_warhead",
    "Defence Missile": "rmb_warhead",
    "Intercept Missile": "rmb_warhead",
    "Anti-Thargoid Missile": "rmb_thargoid_missile",
    "Lawmaker Missile": "rmb_law_missile",
    "Fragmentation Missile": "rmb_frag_missile",
    "Cascade Missile": "rmb_cascade_missile",
    "Override Missile": "rmb_override_missile",
    "Ice Boulder": "iceboulder",
    "Iceteroid": "iceteroid",
    "Unknow Item": "stealth_artefact",
    "Unknown Item": "stealth_artefact", // in case the previous item gets its spelling fixed
    "Homing Mine (Inactive)": "stealth_mine",
    "Stealth Spy Satellite": "blackmonk_minesweeper",
    "ECM Hardened Missile": "ecm_missile",
    "Station Killer Missile":  "ecm_missile",
    "Solar Radiation Disrupter Missile": "ecm_missile",
    "Missile": "missile",
    "Trident Missile": "trident_missile",
    "Mine": "rmb_mine",
    "Proximity Mine": "buoy",
    "Quirium Cascade Mine": "qbomb",
    "Autoskimmer": "qbomb",
    "Probe Missile": "probe_missile",
    "Tracker Missile": "probe_missile",
    "Mini-missile": "probe_missile",
    "Cutpurse Missile": "missile",
    "Kicker Missile": "missile",
    "MM Standard Missile": "missile",
    "Displacer Missile": "ecm_missile",
    "MM Hardened Missile": "ecm_missile",
    "Anti-missile dart": "ams_dart",
    "Interdictor Mine": "interdictor_mine",
    "Screamer Mine": "interdictor_mine",
    "Bomb": "stun_bomb",
    "Void Bomb": "void_bomb",
    "Anti-Thargoid Drone": "antithargoid_drone",
    "Combat Drone": "antithargoid_drone",
    "Kamikaze Drone": "kamikaze_drone",

    //navi
    "Navigation Buoy": "buoy",
    "Training Buoy": "buoy",
    "Witchpoint Beacon": "buoy",
    "Rock Hermit Buoy": "buoy",
    "Communications relay": "buoy",
    "GalCop Navy Buoy": "buoy",
    "Distress Beacon": "buoy",
    "Solar Navigation Buoy": "buoy",
    "Tournament Buoy": "buoy",
    //dockable
    "Coriolis Station": "coriolis",
    "Training Station": "coriolis",
    "Dodecahedron Station": "dodo",
    "Leesti High": "dodo",
    "Icosahedron Station": "ico",
    "Rock Hermit": "rockhermit",
    "Pirate Base": "rockhermit",
    "Free Trade Zone": "rockhermit",
    "Slaver Base": "rockhermit",
    "Rock Hermit: The La Bruja Facility": "rockhermit",
    "Pirate Rock": "rockhermit",
    "Abandoned Rock Hermit: GAL-ID Unit Offline": "rockhermit",
    "Katik Asteroid": "rockhermit",
    "Mining Facility: The Odd Job": "rockhermit",
    "Dodechedron Station": "dodo",
    "Oodles Con Store": "constore",
    "GalaxyMart Con Store": "constore",
    "Pi-42 Con Store": "constore",
    "Star Con Store": "constore",
    "Mall-Wart Con Store": "constore",
    "Sainsboory's Con Store": "constore",
    "Tescoo Con Store": "constore",
    "G-Z1 Icosahedron": "ico_alt",
    "PG-W1 Icosahedron": "ico_alt",
    "G-X1 Icosahedron": "ico_alt",
    "PG-C1 Icosahedron": "ico_alt",
    "PG-W2 Icosahedron": "ico_alt",
    "DS-A1 Icosahedron": "deepspace_ico",
    "S-A1 Icosahedron": "deepspace_ico",
    "Waspline Coriolis": "coriolis_alt",
    "Greenline Coriolis": "coriolis_alt",
    "RaTech Coriolis": "coriolis_alt",
    "SolarTec Coriolis": "coriolis_alt",
    "Metaforce Coriolis": "coriolis_alt",
    "G-X1 Coriolis": "coriolis_alt",
    "RedTec Coriolis": "coriolis_alt",
    "GASE Dodecahedron": "dodo_alt",
    "Axtech Dodecahedron": "dodo_alt",
    "LX5 Dodecahedron": "dodo_alt",
    "Trontech Dodecahedron": "dodo_alt",
    "CK-I1 Dodecahedron": "dodo_alt",
    "Mayan Dodecahedron": "dodo_alt",
    "CK-A1 Dodecahedron": "dodo_alt",
    "N-X1 Dodecahedron": "dodo_alt",
    "G-Z1 Dodecahedron": "dodo_alt2",
    "Super Hub": "superhub",
    "Super Hub I": "superhub",
    "Super Hub II": "superhub",
    "Super Hub III": "superhub",
    "Super Hub IV": "superhub",
    "Trade Outpost": "trade_outpost",
    "Tetrahedron Depot": "tetrahedron",
    "G-Z2 Tetrahedron": "tetrahedron",
    "G-Z2 Octahedron": "octahedron",
    "Octahedron Outpost": "octahedron",
    "Globe Station II": "globe_station",
    "M-G2 Globe": "globe_station",
    "Globe Station III": "globe_station_xl",
    "M-G3 Globe": "globe_station_xl",
    "DS-A1 Coriolis": "deepspace_coriolis",
    "N-A1 Coriolis": "deepspace_coriolis",
    "DS-A1 Dodecahedron": "deepspace_dodo",
    "S-A1 Dodecahedron": "deepspace_dodo",
    "S-A1 Coriolis": "smivs_coriolis",
    "Sodalite Station": "sodalite",
    "M-T1 Torus": "tori_a",
    "Torus Station": "tori_a",
    "M-T2 Torus": "tori_b",
    "Sentinel Station": "sentinel",
    "Renegade Station": "sentinel",
    "G-Z1 Octahedron": "octahedron2",
    "G-Z1 Tetrahedron": "tetrahedron2",
    "Astromine Penal Colony": "astromine",
    "Mining Outpost": "miningoutpost",
    "Kiota Solar": "wildships_2solar",
    "Kiota Manufacturing": "wildships_2disc",
    "Kiota Relay": "wildships_2comms",
    "Kiota Habitat": "wildships_2ring",
    "Kiota Biosphere": "wildships_4sphere",
    "Kiota Research": "wildships_4spur",
    "Kiota Mega Habitat": "wildships_8ring",
    "Darkside Distillery": "distillery",
    "Moonshine Saloon": "saloon",
    "Habitat Mark II": "hab_mk2",
    "Avernus Orbital": "avernus",
    "Imperial AstroFactory": "astrofactory",
    "Taxi Station": "taxi_station",
    "Jaguar Company Base": "jaguar_company",
    "Navy Base": "coyote_navy_station",
    "Salvage Gang": "salvage_gang",
    "Hacker Outpost": "hacker_outpost",
    "Sun Research Station Alpha": "wildships_2solar",
    "Sun Research Station Beta": "coriolis",
    "Sun Research Station Omega": "wildships_2solar",
    "Sun Research Station Delta": "coriolis",
    "Tionisla Orbital Graveyard": "dodo_alt",
    "Broadcast Array": "broadcast_array",
    "Refuelling Station": "fuel_station",
    "Behemoth Type 1": "behemoth_1",
    "Behemoth Type 2": "behemoth_2",
    "Behemoth Type 3": "behemoth_3",
    "Behemoth Type 4": "behemoth_4",
    "Behemoth - Hera": "behemoth_4",
    "Behemoth (Hijacked)": "behemoth_1",
    "Navy Class Carrier": "navy_carrier",
    "Black Monk Monastery": "blackmonk_monastery",
    "Erehwon Station": "erehwon_station",
    "Orisis class hospital": "hospitalship",
    "Tigershark": "tigershark",
    "A Seedy Space Bar": "spacebar",
    "Cruise Ship 'Ronald'": "smivs_liner",
    "Cruise Ship 'Patricia'": "smivs_liner",
    "Saga Class Cruise Ship": "smivs_liner",
    "Generation Ship": "generationship",
    "Collective ZGF": "comfactory",
    "RRS Headquarters": "rrs_headquarters",
    "Deep Space Dredger": "dredger",
    "Dredger Trader": "dredgertrader",
    "Dredger Salvage Droid": "salvagedroid",
    "Super Dredger": "superdredger",
    "Sabre": "sabre",
    "Fury": "fury_ds",
    "Dredger Shuttle": "dredgershuttle",
    "RRS Waystation": "rescue_station",
    "Aurora Galaxy Liner": "aurora",
    "Emerald Class Liner": "emerald",
    "Royal Hunting Lodge": "hunting_lodge",
    "Academy Orbital Station": "laveacademy",
    "Nuit Station": "nuit",
    "Sothis Station": "sothis",
    "SIRF Station": "sirf",
    "Imperial Navy Carrier (Komodo Class)": "komodo",
    "Imperial Navy Headquarters": "himsn_hq",
    "Imperial Navy Outpost": "himsn_outpost",
    "Hathor Station": "hathor",
    "Nephthys Station": "nephthys",
    "Collective SLAPU": "slapu",
    "Gateway Station": "gateway",
    "Aquarian Shipbuilding Corp. HQ": "aquatics_hq",
    "Leviathan System Platform": "aquatics_platform",
    "Leviathan System Platform (Hijacked)": "aquatics_platform",
    "The Link Base": "ionics_link_base",
    "Ionics CR150 Weapons Platform": "ionics_wplatform",
    "Taranis Corporation HQ": "taranis",
    "HoOpy Casino": "hoopy_casino",
    "Navy SecCom Station": "navystation",
    "KHS-4R Orbiter": "wildships_4ring",
    "KHS-2R Orbiter": "wildships_2ring",
    "KHS-8R Orbiter": "wildships_8ring",
    "KOS-RJ Orbiter": "wildships_4spur",
    "KOS-RM Orbiter": "wildships_2spur2sphere",
    "KOS-RT Orbiter": "wildships_2spur2sphere",
    "KOS-RS Orbiter": "wildships_2spur2sphere",
    "KOS-P Orbiter": "wildships_2disc2solar",
    "KOS-M Orbiter": "wildships_2spur2solar",
    "Dodecahedron Station: Port Liberty": "dodo_alt3",
    "The Augeaian Orbital Repair Facility": "dodo_alt3",
    "Hoopy Hotel: Light of Lernean": "dodo_alt3",
    "Hoopy Hotel: Hospitality of Hades": "dodo_alt3",
    "Wiseguy Waystation: Hesperides Central": "dodo_alt3",
    "Griff Research Orbital Base": "dodo_alt3",
    "Rebel Outpost: New Hope": "ionics_link_base",
    "Military Base: Red Devil": "milbase",
    "GRS Buoy Factory": "grs_station",
    "Draven Oodulldoff Station": "draven_station",
};

this._disambiguation = {
    "feudal-boa": "boa",
    "feudal-boa2": "boa_cruiser",
    "feudal-moray": "moray",
    "feudal-python": "python",
    "feudal-anaconda": "anaconda",
    "feudal-adder": "adder",
};

this._operationalFunctionNames = [ // list of functions to enable/disable at HUDSelector callback
    "shipWillDockWithStation",
    "shipWillLaunchFromStation",
    "shipExitedWitchspace",
    "shipDied",
    "guiScreenChanged",
    "alertConditionChanged",
    "compassTargetChanged",
    "shipTargetAcquired",
    "playerBoughtNewShip"
];

//----------------------------------------------------------------------------------------
this.startUp = function _vimanaXHUD_startUp() {
    var i = 0;
    this._combatMFD = worldScripts["combat_MFD"];
    this.$measureText();
    var p = player.ship;
    p.crosshairs = "vx_crosshair_off.plist";
    p.setCustomHUDDial("VimanaX_Rh", "");
    if (!missionVariables.ironHide_percentage) missionVariables.ironHide_percentage = 0;
    for (i = 0; i < 8; i++) {
        this._govs.push(String.fromCharCode(i));
        this._ecos.push(String.fromCharCode(23 - i));
    }

    if (worldScripts["telescope"]) {
        this._TLS = worldScripts["telescope"];
        this._TLS.$TelescopeVSize = 4;
        this._TLS.$TelescopeVZoomSize = 4;
    }

    var w;
    if (worldScripts.shieldequalizercapacitors) this._SEC = worldScripts.shieldequalizercapacitors;
    if (worldScripts.sniperlock) this._SLS = worldScripts.sniperlock;
    if (worldScripts.sniperlock_plus) this._SLP = worldScripts.sniperlock_plus;
    if (worldScripts["Auto Crosshairs"]) this._ACH = worldScripts["Auto Crosshairs"];
    if (worldScripts.ams_system) this._AMS = worldScripts.ams_system; else this._setSlot1 = 0;
    if (worldScripts["Target Filtering System"]) this._TFS = worldScripts["Target Filtering System"];
    w = worldScripts["Repair System"];
    if (w && w.version && w.version >= "2.14") this._SRS = w; else this._setSlot2 = 0;
    w = worldScripts["Shield Cycler"];
    if (w && w.version && w.version >= "2.1") this._SC = w;
    if (worldScripts.LMSS_Core) this._LMSS = worldScripts.LMSS_Core;

    var hs = null;
    if (worldScripts.hudselector) hs = worldScripts.hudselector;
    if (hs) {
        hs.$HUDSelectorAddHUD("Vimana-X HUD 6 MFDs", this.name + "-6mfds");
        hs.$HUDSelectorAddHUD("Vimana-X HUD 10 MFDs", this.name + "-10mfds");
        hs.$HUDSelectorAddHUD("Vimana-X HUD 12 MFDs", this.name + "-12mfds");
    } else {
        p.hud = this.name + "_docked.plist";
    }
    i = p.equipment.length;
    while (i--) {
        if (p.equipmentStatus(p.equipment[i].equipmentKey) === "EQUIPMENT_DAMAGED") this._eqDamaged.push(p.equipment[i].name);
    }

    this._targetHeader = this.$padText(".: TARGET INFO :.", 9.16, false, true);
    this._travelHeader = this.$padText(".: TRAVEL INFO :.", 9.16, false, true);
    this._checkList = this.$padText("..:: CheckList ::..", 12.03, true, true);
    this._shipDamaged = this.$padText("SHIP DAMAGED!", 9.74, true, true);
    this._shipInfo = this.$padText(".: SHIP INFO :.", 9.16, true, true);
    this._nextHops = this.$padText("...: NEXT HOPS :...", 12.03, true, true);

    // if the player has already bought the original modules, auto-award them in this new save game (should only happen one time)
    if (!missionVariables.VimanaX_HUD_Style) {
        if (p.equipmentStatus("EQ_VIMANA_TARGET_MODULE") == "EQUIPMENT_OK" || p.equipmentStatus("EQ_VIMANAX_TARGET_MODULE") == "EQUIPMENT_UNAVAILABLE") p.awardEquipment("EQ_VIMANAX_TARGET_MODULE");
        if (p.equipmentStatus("EQ_VIMANA_TRAVEL_MODULE") == "EQUIPMENT_OK" || p.equipmentStatus("EQ_VIMANAX_TRAVEL_MODULE") == "EQUIPMENT_UNAVAILABLE") p.awardEquipment("EQ_VIMANAX_TRAVEL_MODULE");
        if (p.equipmentStatus("EQ_VIMANA_SHIP_MODULE") == "EQUIPMENT_OK" || p.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") == "EQUIPMENT_UNAVAILABLE") p.awardEquipment("EQ_VIMANAX_SHIP_MODULE");
    }

    if (missionVariables.VimanaX_HUD_SpecialSlot1) this._setSlot1 = parseInt(missionVariables.VimanaX_HUD_SpecialSlot1);
    if (missionVariables.VimanaX_HUD_SpecialSlot2) this._setSlot2 = parseInt(missionVariables.VimanaX_HUD_SpecialSlot2);
    this.$changeSettings();
    if (missionVariables.VimanaX_HUD_DisableAlerts) worldScripts.VimanaX_Alerts._disabled = (missionVariables.VimanaX_HUD_DisableAlerts == "1" ? true : false);
    if (missionVariables.VimanaX_HUD_Style) this._style = missionVariables.VimanaX_HUD_Style;
    if (missionVariables.VimanaX_HUD_NonLinear) this._nonLinear = (missionVariables.VimanaX_HUD_NonLinear == "1" ? true : false);
    if (missionVariables.VimanaX_HUD_UltraZoom) this._ultraZoom = (missionVariables.VimanaX_HUD_UltraZoom == "1" ? true : false);
    this.$updateHUDSelectorSettings();
}

//-------------------------------------------------------------------------------------------------------------
this.startUpComplete = function _vimanaXHUD_startUpComplete() {
    this.$initInterface(player.ship.dockedStation);
    if (worldScripts.ShipConfiguration_F3HUDControl) {
        if (player.ship.hud.indexOf(this.name) >= 0) this.$updateShipConfigHUD();
    }
}

//-------------------------------------------------------------------------------------------------------------
this.playerBoughtNewShip = function _vimanaXHUD_playerBoughtNewShip(ship, price) {
    this.$initInterface(player.ship.dockedStation);
}

//----------------------------------------------------------------------------------------
this.playerWillSaveGame = function _vimanaXHUD_playerWillSaveGame() {
    missionVariables.VimanaX_HUD_SpecialSlot1 = this._setSlot1;
    missionVariables.VimanaX_HUD_SpecialSlot2 = this._setSlot2;
    missionVariables.VimanaX_HUD_DisableAlerts = (worldScripts.VimanaX_Alerts._disabled ? "1" : "0");
    missionVariables.VimanaX_HUD_Style = this._style;
    missionVariables.VimanaX_HUD_NonLinear = (this._nonLinear ? "1" : "0");
    missionVariables.VimanaX_HUD_UltraZoom = (this._ultraZoom ? "1" : "0");
}

//----------------------------------------------------------------------------------------
this.$HUDSelectorCallBack = function _vimanaXHUD_HUDSelectorCallBack(off) {
    var ws = worldScripts.VimanaX_HUD;
    var pship = player.ship;
    var funcNames = this._operationalFunctionNames;
    var i = funcNames.length;
    if (this._debug) log(this.name, "HUDSelectorCallBack, off:" + off + ", pship.hud:" + pship.hud);
    if (off) {
        // disable
        ws.$stopTimers();
        while (i--)
            if (ws[funcNames[i]]) {
                ws["$save_" + funcNames[i]] = ws[funcNames[i]];
                delete ws[funcNames[i]];
            }
        if (pship.dockedStation) pship.dockedStation.setInterface(this.name, null);
        worldScripts.VimanaX_Alerts.$disableAlerts();
        ws.$revertShipConfigHUD();
    } else {
        // enable
        while (i--)
            if (!ws[funcNames[i]]) {
                ws[funcNames[i]] = ws["$save_" + funcNames[i]];
            }
        this._inflightHUD = pship.hud;
        if (!pship.docked) {
            ws.shipWillLaunchFromStation();
        } else {
            pship.hud = "VimanaX_HUD_docked.plist";
        }
        this.$updateHUDSelectorSettings();
        if (pship.dockedStation) this.$initInterface(pship.dockedStation);
        worldScripts.VimanaX_Alerts.$enableAlerts();
        ws.$updateShipConfigHUD();
    }
}

//----------------------------------------------------------------------------------------
this.shipWillDockWithStation = function _vimanaXHUD_shipWillDockWithStation(station) {
    var p = player.ship;

    this.$stopTimers();
    if (isValidFrameCallback(this._cbf)) removeFrameCallback(this._cbf);
    this._cbf = null;
    if (isValidFrameCallback(this.$AnimCB)) removeFrameCallback(this._cbf);
    this.$AnimCB = null;
    this._lastUsed[13] = "";
    this._inflightHUD = p.hud;
    p.hud = "VimanaX_HUD_docked.plist";

    this.$initInterface(station);
}

//----------------------------------------------------------------------------------------
this.shipDied = function _vimanaXHUD_shipDied() {
    this.$stopTimers();
    if (isValidFrameCallback(this._cbf)) removeFrameCallback(this._cbf);
    this._cbf = null;
    if (isValidFrameCallback(this.$AnimCB)) removeFrameCallback(this._cbf);
    this.$AnimCB = null;
    this._lastUsed[13] = "";
}

//----------------------------------------------------------------------------------------
this.shipWillLaunchFromStation = function _vimanaXHUD_shipWillLaunchFromStation() {
    this.$setHUDEquipment(false);
    this._timer1Ping = false;
    this._timer2Ping = false;
    this._timer3Ping = false;
    this._killsOnLaunch = player.score;
    var p = player.ship;
    var i = 20;
    while (i--) { this._lastUsed[i] = null; }

    if (this._inflightHUD) p.hud = this._inflightHUD;

    if (!isValidFrameCallback(this._cbf))
        this._cbf = addFrameCallback(this.$showIndicators.bind(this));

    this.$checkMaint();

    //set player ship image
    this._hullAnim[0] = (this._gameShips[p.name] ? this._gameShips[p.name] : "");
    if (this._hullAnim[0] == "**") this._hullAnim[0] = this._disambiguation[p.dataKey];
    this.$AlertNo = 0;

    i = p.equipment.length;
    while (i--) {
        if (p.equipment[i].damageProbability > 0) this._lastUsed[16]++;
    }

    var sc = worldScripts.ShipConfiguration_Core;
    if (sc) {
        var a = sc._armour;
        if (a && a.length > 0) {
            i = a.length;
            while (i--) {
                if (a[i] && p.equipmentStatus(a[i]) === "EQUIPMENT_OK") {
                    this._SC_Armour = true;
                    break;
                }
            }
        }
    }

    if (!this._infoTimer) this._infoTimer = new Timer(this, this.$showInfo.bind(this), 2, 0.25);
    if (!this._iconTimer) this._iconTimer = new Timer(this, this.$showIcon.bind(this), 1, 0.5);
    this.$startAnim();
    this.$equipmentStatus();
    this._lastUsed[12] = 1;
    this.$setLPanel();

    // this will be redundant if HUD selector gets there first, but just in case
    p.hud.scannerUltraZoom = this._ultraZoom;
    p.hud.scannerNonLinear = this._nonLinear;
}

//----------------------------------------------------------------------------------------
this.guiScreenChanged = function _vimanaXHUD_guiScreenChanged(to, from) {
    if (from === "GUI_SCREEN_SHORT_RANGE_CHART" || from === "GUI_SCREEN_LONG_RANGE_CHART") {
        this._lastUsed[12] = 1;
        this.$setLPanel();
    }
}

//----------------------------------------------------------------------------------------
this.equipmentRepaired = function _vimanaXHUD_equipmentRepaired(equipment) { //repaired
    var p = player.ship;
    var i = p.equipment.length;
    while (i--) {
        if (this._eqDamaged[i] == EquipmentInfo.infoForKey(equipment).name) this._eqDamaged.splice(i, 1);
    }
    this.$equipmentStatus();
    if (equipment == "EQ_VIMANAX_SHIP_MODULE") this.$startAnim();
}

//----------------------------------------------------------------------------------------
this.equipmentDamaged = function _vimanaXHUD_equipmentDamaged(equipment) {    //damaged
    var eq = EquipmentInfo.infoForKey(equipment);
    if (eq.isVisible) {
        this._eqDamaged.push(EquipmentInfo.infoForKey(equipment).name);
        this.$equipmentStatus();
    }
}

//----------------------------------------------------------------------------------------
this.shipTargetAcquired = function _vimanaXHUD_shipTargetAcquired(target) {
    if (target.isWormhole) return;
    var p = player.ship;
    p.setCustomHUDDial("VimanaX_LPTitle", this._targetHeader);
    p.setCustomHUDDial("VimanaX_SClock", "");
    p.setCustomHUDDial("VimanaX_CEnergy", "");
    p.setCustomHUDDial("VimanaX_CSpeed", "");
    p.setCustomHUDDial("VimanaX_CMissile", "");

    if (p.equipmentStatus("EQ_VIMANAX_TARGET_MODULE") === "EQUIPMENT_OK") {
        var m = null;
        //set ship model and name
        m = (this._gameShips[target.name] ? "vx_" + this._gameShips[target.name] + ".png" : null);
        if (m && m == "vx_***.png") m = "vx_" + this._disambiguation[target.dataKey] + ".png";
        if (m) var model = m; else var model = "vx_blank.png";
        p.setCustomHUDDial("VimanaX_PTarget", model);
    }
}

//----------------------------------------------------------------------------------------
this.shipExitedWitchspace = function _vimanaXHUD_shipExitedWitchspace() {
    this.$checkMaint();
    this._lastUsed[12] = 1;
    this._lastUsed[13] = "";
    this.$setLPanel();
}

//----------------------------------------------------------------------------------------
this.alertConditionChanged = function _vimanaXHUD_alertConditionChanged(newState, oldState) {
    var cond = ["", "green_", "", "red_"][newState];
    if (this._debug) log(this.name, "Setting player's crosshairs to vx_" + cond + "crosshair_off.plist");
    player.ship.crosshairs = "vx_" + cond + "crosshair_off.plist";
    if (this._ACH) {
        this._ACH.$crosshairs.default.off = this._ACH.$offTargetCrosshairs = "vx_" + cond + "crosshair_off.plist";
        this._ACH.$onTargetCrosshairs = this._ACH.$crosshairs.default.on = "vx_" + cond + "crosshair_on.plist";
    }
}

//----------------------------------------------------------------------------------------
this.compassTargetChanged = function _vimanaXHUD_compassTargetChanged(whom, mode) {
    if (!whom) return;
    var target = "";
    if (mode === "COMPASS_MODE_BASIC") {
        if (whom.isPlanet) target = "Planet";
        else target = "Main Station";
    } else if (mode === "COMPASS_MODE_PLANET") {
        var s = System.infoForSystem(galaxyNumber, system.info.systemID);
        var ex = this._ecos[s.economy] + this._govs[s.government] + (s.techlevel + 1);
        target = whom.name + ex;
    } else if (mode === "COMPASS_MODE_TARGET") {
        target = "Target";
    } else {
        if (whom.beaconLabel) target = whom.beaconLabel;
        else if (whom.displayName) target = whom.displayName;
        else if (whom.name) target = whom.name;
        else if (whom.beaconCode) target = whom.beaconCode;
        else target = "Unidentified";
    }

    player.ship.setCustomHUDDial("VimanaX_ASCName", this.$padText(target, this._widths["VimanaX_ASCName"][this._widthLookup]));
}

/*******************************************************************
*             display hud icons (pictograms)
* ******************************************************************/

//----------------------------------------------------------------------------------------
this.$setHUDEquipment = function _vimanaXHUD_setHUDEquipment(remove) {
    var p = player.ship;
    p.setCustomHUDDial("VimanaX_HUD_Main", "vx_vimana_hud_main_" + this._style + ".png");
    p.setCustomHUDDial("VimanaX_HUD_Surrounds", "vx_vimana_hud_surrounds_" + this._style + ".png");
    p.setCustomHUDDial("VimanaX_WeaponLabel", "WEAPON");
    p.setCustomHUDDial("VimanaX_PrimedLabel", "PRIMED");
    p.setCustomHUDDial("VimanaX_EquipLabel", "EQUIP");
    p.setCustomHUDDial("VimanaX_ModeLabel", "MODE");
    p.setCustomHUDDial("VimanaX_SpeedLabel", "SPEED");
    p.setCustomHUDDial("VimanaX_FuelLabel", "FUEL");
    p.setCustomHUDDial("VimanaX_AltLabel", "ALT");
    p.setCustomHUDDial("VimanaX_CargoLabel", "CARGO");
    p.setCustomHUDDial("VimanaX_CTempLabel", "C.TEMP");
    p.setCustomHUDDial("VimanaX_EnergyLabel", "ENERGY");
    p.setCustomHUDDial("VimanaX_LTempLabel", "L.TEMP");
    p.setCustomHUDDial("VimanaX_FshLabel", "F.SH");
    p.setCustomHUDDial("VimanaX_AshLabel", "A.SH");

    p.removeEquipment("EQ_VIMANAX_FONT_NARROW");
    p.removeEquipment("EQ_VIMANAX_FONT_NORMAL");
    if (!remove) {
        if (this._widthLookup == 1) {
            p.awardEquipment("EQ_VIMANAX_FONT_NARROW");
        } else {
            p.awardEquipment("EQ_VIMANAX_FONT_NORMAL");
        }
    }
}

//----------------------------------------------------------------------------------------
this.$stopTimers = function _vimanaXHUD_stopTimers() {
    if (this._infoTimer) {
        this._infoTimer.stop();
        delete this._infoTimer;
    }
    if (this._iconTimer) {
        this._iconTimer.stop();
        delete this._iconTimer;
    }
    if (this.$AnimTimer) {
        this.$AnimTimer.stop();
        delete this.$AnimTimer;
    }
}

//----------------------------------------------------------------------------------------
this.$startAnim = function _vimanaXHUD_StartAnim() {
    if (player.ship.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") === "EQUIPMENT_OK") {
        if (!this.$AnimTimer) this.$AnimTimer = new Timer(this, this.$animHull.bind(this), 3, 1);
        this._hullAnim[1] = 11;
    }
}

//----------------------------------------------------------------------------------------
this.$showIcon = function _vimanaXHUD_showIcon() {
    var that = _vimanaXHUD_showIcon;
    var _player = (that._player = that._player || player);
    var p = _player.ship;
    if (!p || !p.isValid) return;
    if (!this._timer1Ping) { this._timer1Ping = true; this.$playSound(); }
    var alerts = worldScripts.VimanaX_Alerts;

    var h = this.$getHostileShips();

    if (h.length && p.alertCondition === 3) {
        if (Math.floor((this._iconTimer.nextTime * 10) % 2))
            p.setCustomHUDDial("VimanaX_HCG", "vx_combat.png");
        else
            p.setCustomHUDDial("VimanaX_HCG", "vx_blank.png");
    } else {
        p.setCustomHUDDial("VimanaX_HCG", "vx_blank.png");
    }

    if (this._LMSS) { //lmss icon
        var ws = this._LMSS;
        switch (p.viewDirection) {
            case "VIEW_FORWARD":
                if (p.equipmentStatus("EQ_LMSS_FRONT") === "EQUIPMENT_OK")
                    this.$LMSSIcons(ws._forwardTimer);
                else if (p.equipmentStatus("EQ_LMSS_FRONT") === "EQUIPMENT_DAMAGED")
                    this.$blinkingIcons("VimanaX_Lmss", "vx_lmss_d.png");
                else
                    p.setCustomHUDDial("VimanaX_Lmss", "vx_blank.png");
                break;
            case "VIEW_AFT":
                if (p.equipmentStatus("EQ_LMSS_AFT") === "EQUIPMENT_OK")
                    this.$LMSSIcons(ws._aftTimer);
                else if (p.equipmentStatus("EQ_LMSS_AFT") === "EQUIPMENT_DAMAGED")
                    this.$blinkingIcons("VimanaX_Lmss", "vx_lmss_d.png");
                else
                    p.setCustomHUDDial("VimanaX_Lmss", "vx_blank.png");
                break;
            case "VIEW_PORT":
                if (p.equipmentStatus("EQ_LMSS_PORT") === "EQUIPMENT_OK")
                    this.$LMSSIcons(ws._portTimer);
                else if (p.equipmentStatus("EQ_LMSS_PORT") === "EQUIPMENT_DAMAGED")
                    this.$blinkingIcons("VimanaX_Lmss", "vx_lmss_d.png");
                else
                    p.setCustomHUDDial("VimanaX_Lmss", "vx_blank.png");
                break;
            case "VIEW_STARBOARD":
                if (p.equipmentStatus("EQ_LMSS_STARBOARD") === "EQUIPMENT_OK")
                    this.$LMSSIcons(ws._starboardTimer);
                else if (p.equipmentStatus("EQ_LMSS_STARBOARD") === "EQUIPMENT_DAMAGED")
                    this.$blinkingIcons("VimanaX_Lmss", "vx_lmss_d.png");
                else
                    p.setCustomHUDDial("VimanaX_Lmss", "vx_blank.png");
        }

        if (p.equipmentStatus("EQ_LMSS_ACTUATOR") === "EQUIPMENT_OK")
            p.setCustomHUDDial("VimanaX_LmsA", "vx_lmsa.png");
        else if (p.equipmentStatus("EQ_LMSS_ACTUATOR") === "EQUIPMENT_DAMAGED")
            this.$blinkingIcons("VimanaX_LmsA", "vx_lmsa_d.png");
        else
            p.setCustomHUDDial("VimanaX_LmsA", "vx_blank.png");
    }

    if (p.equipmentStatus("EQ_CLOAKING_DEVICE") === "EQUIPMENT_DAMAGED") this.$blinkingIcons("VimanaX_Cloaking", "vx_invisible_d.png");
    else if (p.isCloaked) this.$blinkingIcons("VimanaX_Cloaking", "vx_invisible.png");
    else p.setCustomHUDDial("VimanaX_Cloaking", "vx_blank.png");

    if (this._SEC) {
        //forward capacitor
        if (p.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") === "EQUIPMENT_DAMAGED")
            this.$blinkingIcons("VimanaX_CapacitorF", "vx_cap_f_d.png");
        else if (p.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") === "EQUIPMENT_OK") {
            if (this._SEC.secforwardshieldcapacitor == 0)
                p.setCustomHUDDial("VimanaX_CapacitorF", "vx_blank.png");
            else if (this._SEC.secforwardshieldcapacitor < this._SEC.$maxCapacitorCharge - p.forwardShieldRecharge)
                this.$blinkingIcons("VimanaX_CapacitorF", "vx_cap_f.png");
            else
                p.setCustomHUDDial("VimanaX_CapacitorF", "vx_cap_f.png");
        } else
            p.setCustomHUDDial("VimanaX_CapacitorF", "vx_blank.png");

        //center dot
        if (p.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") === "EQUIPMENT_DAMAGED" && p.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") === "EQUIPMENT_DAMAGED")
            p.setCustomHUDDial("VimanaX_CapacitorC", "vx_cap_c_d.png");
        else if (p.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") === "EQUIPMENT_OK" && p.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") === "EQUIPMENT_OK")
            p.setCustomHUDDial("VimanaX_CapacitorC", "vx_cap_c.png");
        else if (p.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") === "EQUIPMENT_OK" || p.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") === "EQUIPMENT_OK")
            this.$blinkingIcons("VimanaX_CapacitorC", "vx_cap_b.png", "vx_cap_c.png");
        else
            p.setCustomHUDDial("VimanaX_CapacitorC", "vx_blank.png");

        //aft capacitor    
        if (p.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") === "EQUIPMENT_DAMAGED")
            this.$blinkingIcons("VimanaX_CapacitorA", "vx_cap_a_d.png");
        else if (p.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") === "EQUIPMENT_OK") {
            if (this._SEC.secaftshieldcapacitor == 0)
                p.setCustomHUDDial("VimanaX_CapacitorA", "vx_blank.png");
            else if (this._SEC.secaftshieldcapacitor < this._SEC.$maxCapacitorCharge - p.aftShieldRecharge)
                this.$blinkingIcons("VimanaX_CapacitorA", "vx_cap_a.png");
            else
                p.setCustomHUDDial("VimanaX_CapacitorA", "vx_cap_a.png");
        } else
            p.setCustomHUDDial("VimanaX_CapacitorA", "vx_blank.png");
    } else {
        p.setCustomHUDDial("VimanaX_CapacitorF", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_CapacitorC", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_CapacitorA", "vx_blank.png");
    }

    if (p.equipmentStatus("EQ_SHIELD_EQUALIZER") === "EQUIPMENT_OK")
        p.setCustomHUDDial("VimanaX_SCycler", "vx_sc.png");
    else if (p.equipmentStatus("EQ_SHIELD_EQUALIZER") === "EQUIPMENT_DAMAGED")
        this.$blinkingIcons("VimanaX_SCycler", "vx_sc_d.png");
    else if (this._SC && this._SC._SC_settings && this._SC._SC_settings.version) {
        if (this._SC._SC_settings.functional == 100)
            p.setCustomHUDDial("VimanaX_SCycler", "vx_sc.png");
        else
            this.$blinkingIcons("VimanaX_SCycler", "vx_sc_d.png");
    } else
        p.setCustomHUDDial("VimanaX_SCycler", "vx_blank.png");

    //EQ_NAVAL_ENERGY_UNIT
    if (p.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_UNAVAILABLE" && p.equipmentStatus("EQ_NAVAL_ENERGY_UNIT") === "EQUIPMENT_UNAVAILABLE")
        p.setCustomHUDDial("VimanaX_EEnergy", "vx_blank.png");
    else {
        if (p.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK")
            p.setCustomHUDDial("VimanaX_EEnergy", "vx_eeu.png");
        else if (p.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_DAMAGED")
            this.$blinkingIcons("VimanaX_EEnergy", "vx_eeu_d.png");
        else if (p.equipmentStatus("EQ_NAVAL_ENERGY_UNIT") === "EQUIPMENT_OK")
            p.setCustomHUDDial("VimanaX_EEnergy", "vx_neu.png");
        else if (p.equipmentStatus("EQ_NAVAL_ENERGY_UNIT") === "EQUIPMENT_DAMAGED")
            this.$blinkingIcons("VimanaX_EEnergy", "vx_eeu_d.png");
    }

    if (p.equipmentStatus("EQ_ECM") === "EQUIPMENT_OK") p.setCustomHUDDial("VimanaX_ECM", "vx_ecm_o.png");
    else if (p.equipmentStatus("EQ_ECM") === "EQUIPMENT_DAMAGED") this.$blinkingIcons("VimanaX_ECM", "vx_ecm_d.png");

    if (this._maintenance == true) this.$blinkingIcons("VimanaX_Service", "vx_maintenance.png");
    else p.setCustomHUDDial("VimanaX_Service", "vx_blank.png");

    if (p.equipmentStatus("EQ_FUEL_INJECTION") === "EQUIPMENT_DAMAGED" || p.fuel < 0.1) this.$blinkingIcons("VimanaX_FInjector", "vx_injector_d.png");
    else if (p.equipmentStatus("EQ_FUEL_INJECTION") === "EQUIPMENT_OK") p.setCustomHUDDial("VimanaX_FInjector", "vx_injector.png");
    else p.setCustomHUDDial("VimanaX_FInjector", "vx_blank.png");

    if (((p.fuel).toFixed(1) < this._reqFuel && system.ID != p.targetSystem) || p.fuel < 0.1) this.$blinkingIcons("VimanaX_FuelAlert", "vx_low_fuel.png");
    else p.setCustomHUDDial("VimanaX_FuelAlert", "vx_blank.png");


    //self repair system icons 
    var eqKey = (this._SRS && this._SRS.$controllerVersion ? this._SRS.$controllerVersion : null);
    if (eqKey) {
        if (this._SRS.$selfRepairsSystemStatus === "Active")
            this.$blinkingIcons("VimanaX_RepIcon", "vx_srs_0.png", "vx_srs_1.png");
        else if (this._SRS.$selfRepairsSystemStatus === "Self-repair")
            this.$blinkingIcons("VimanaX_RepIcon", "vx_srs_d.png", "vx_blank.png");
        else if (this._SRS.$selfRepairsSystemStatus === "Standby")
            p.setCustomHUDDial("VimanaX_RepIcon", "vx_srs.png");
        else if (this._SRS.$selfRepairsSystemStatus === "Shutdown")
            p.setCustomHUDDial("VimanaX_RepIcon", "vx_srs_d.png");
        else
            p.setCustomHUDDial("VimanaX_RepIcon", "vx_blank.png");
    } else
        p.setCustomHUDDial("VimanaX_RepIcon", "vx_blank.png");

    if (p.energy < p.maxEnergy / 3) this.$blinkingIcons("VimanaX_EnergyAlert", "vx_alert_red.png");
    else if (p.energy < p.maxEnergy / 2) this.$blinkingIcons("VimanaX_EnergyAlert", "vx_alert_orange.png");
    else p.setCustomHUDDial("VimanaX_EnergyAlert", "vx_blank.png");

    var ctmp = Math.round(100 * p.temperature);
    if (ctmp > 70) this.$blinkingIcons("VimanaX_CTempAlert", "vx_alert_red.png");
    else if (ctmp > 50) this.$blinkingIcons("VimanaX_CTempAlert", "vx_alert_orange.png");
    else p.setCustomHUDDial("VimanaX_CTempAlert", "vx_blank.png");

    if (p.forwardShield < p.maxForwardShield * 0.2) this.$blinkingIcons("VimanaX_FshAlert", "vx_alert_red.png");
    else if (!p.torusEngaged && p.forwardShield < p.maxForwardShield / 2) this.$blinkingIcons("VimanaX_FshAlert", "vx_alert_orange.png");
    else p.setCustomHUDDial("VimanaX_FshAlert", "vx_blank.png");

    if (p.aftShield < p.maxAftShield * 0.2) this.$blinkingIcons("VimanaX_AshAlert", "vx_alert_red.png");
    else if (!p.torusEngaged && p.aftShield < p.maxAftShield / 2) this.$blinkingIcons("VimanaX_AshAlert", "vx_alert_orange.png");
    else p.setCustomHUDDial("VimanaX_AshAlert", "vx_blank.png");

    if (alerts._lastAlert[4] < 10000) this.$blinkingIcons("VimanaX_AltAlert", "vx_alert_orange.png");
    else p.setCustomHUDDial("VimanaX_AltAlert", "vx_blank.png");

    if (alerts._incomingMiss) this.$blinkingIcons("VimanaX_MissAlert", "vx_target.png");
    else p.setCustomHUDDial("VimanaX_MissAlert", "vx_blank.png");

}

//----------------------------------------------------------------------------------------
this.$LMSSIcons = function _vimanaXHUD_LMSSIcons(tmr) {
    var p = player.ship;
    if (tmr && tmr.isRunning) {
        if (Math.floor(this._iconTimer.nextTime * 10) & 1) p.setCustomHUDDial("VimanaX_Lmss", "vx_lmss1.png");
        else p.setCustomHUDDial("VimanaX_Lmss", "vx_lmss0.png");
    } else {
        p.setCustomHUDDial("VimanaX_Lmss", "vx_lmss0.png");
    }
}

//----------------------------------------------------------------------------------------
this.$blinkingIcons = function _vimanaXHUD_blinkingIcons(key, ico, blank) {
    if (blank == null) blank = "vx_blank.png";
    if (Math.floor(this._iconTimer.nextTime * 10) & 1) {
        player.ship.setCustomHUDDial(key, ico);
    } else {
        player.ship.setCustomHUDDial(key, blank);
    }
}

//----------------------------------------------------------------------------------------
this.$getHostileShips = function _vimanaXHUD_getHostileShips() {
    return this.$filterEntities(
        function (e) { return (e.isShip && e.hasHostileTarget && e.target === player.ship); }
    );
};

//----------------------------------------------------------------------------------------
this.$filterEntities = function _vimanaXHUD_filterEntities(filterFunc) {
    return system.filteredEntities(
        this,
        filterFunc,
        player.ship,
        player.ship.scannerRange
    );
}

//----------------------------------------------------------------------------------------
this.$showInfo = function _vimanaXHUD_showInfo() { //txt information on the hud
    var that = _vimanaXHUD_showInfo;
    var _padText = (that._padText = that._padText || this.$padText);
    var p = player.ship;
    if (!this._timer2Ping) { this._timer2Ping = true; this.$playSound(); }

    var col1 = 1.1;
    var col2 = 10.9;
    if (this._widthLookup == 1) {col1 = 2; col2 = 11.35;}
    /**************************************
     * display a list of damaged equipment
     **************************************/
    //right panel
    p.setCustomHUDDial("VimanaX_RPTitle", this._shipInfo);
    if (p.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") === "EQUIPMENT_OK") {
        if (this._eqDamaged.length && !(Math.floor(this._infoTimer.nextTime * 100) % 4)) {
            if (this._eqDamaged.length < 9) {
                var poz = this._lastUsed[14] = 0;
            } else {
                if (this._lastUsed[14] > this._eqDamaged.length - 1) this._lastUsed[14] = 0;
                var poz = this._lastUsed[14];
                this._lastUsed[14]++;
            }
            for (let i = 0; i < 9; i++) {
                if (i > this._eqDamaged.length - 1) break;
                let y = poz + i;
                if (y > this._eqDamaged.length - 1) y -= this._eqDamaged.length;
                let dsp = _padText((1 + y).toString(), col1, true) + _padText(". " + this._eqDamaged[y], col2);
                let ln = i + 1;
                p.setCustomHUDDial("VimanaX_R" + ln, dsp);
            }
        }
    }

    if (p.alertCondition === 3) {
        if ((this._SLS && this._SLS.sniperlockchangeflag && this._SLS.sniperlockchangeflag === "ON") ||
            (this._SLP && this._SLP._SLPState === "ON"))
            p.setCustomHUDDial("VimanaX_TLock", "LOCKED");
        else
            p.setCustomHUDDial("VimanaX_TLock", "");
        //hostile counter
        var hc = [];
        hc = this.$getHostileShips();
        if (hc.length > 0) {
            if (hc.length > 9)
                p.setCustomHUDDial("VimanaX_HC", hc.length);
            else
                p.setCustomHUDDial("VimanaX_HC", " " + hc.length);
        }
    } else {
        p.setCustomHUDDial("VimanaX_TLock", "");
    }
    this.$setLPanel();

    //special slots 
    //repairbots status/ams system/heat sinks/ore processor
    var i = this._specialSlots.length;
    while (i--) {
        var slotData = "VimanaX_SpecialSlot" + (i + 1).toString();
        var slotLabel = "VimanaX_SpecialSlot" + (i + 1).toString() + "Label";
        var outputLabel = "";
        var outputData = "";
        switch (this._specialSlots[i]) {
            case "SRS":
                outputLabel = "SR.SYS";
                if (this._SRS && this._SRS.$controllerVersion)
                    outputData = this._SRS.$selfRepairsSystemStatus + ", Charges: " + missionVariables.repairCounter;
                break;
            case "AMS":
                outputLabel = "AM.SYS";
                if (p.equipmentStatus("EQ_AMS") === "EQUIPMENT_OK" && missionVariables.amActive === "ACTIVE" && this._AMS.amCount)
                    outputData = "Darts: " + this._AMS.amCount;
                else if (p.equipmentStatus("EQ_AMS") === "EQUIPMENT_OK") outputData = "OFFLINE";
                else if (p.equipmentStatus("EQ_AMS") === "EQUIPMENT_DAMAGED") outputData = "DAMAGED";
                else outputData = "";
                break;
            case "HEATSINK":
                outputLabel = "H.SINK";
                if (p.equipmentStatus("EQ_HEAT_SINK_CONTROL") === "EQUIPMENT_OK") outputData = "Manual deploy: ";
                if (p.equipmentStatus("EQ_HEAT_SINK_CONTROL") === "EQUIPMENT_DAMAGED") outputData = "DAMAGED";
                if (p.equipmentStatus("EQ_HEAT_SINK_CONTROL_PASSIVE") === "EQUIPMENT_OK") outputData = "Auto deploy: ";
                if (p.equipmentStatus("EQ_HEAT_SINK_CONTROL_PASSIVE") === "EQUIPMENT_DAMAGED") outputData = "DAMAGED";
                if (outputData != "DAMAGED") {
                    var hs = p.equipmentStatus("EQ_HEAT_SINK", true)["EQUIPMENT_OK"];
                    if (hs > 0) outputData += hs + " avail";
                }
                break;
            case "OREPROC":
                outputLabel = "ORE.PR";
                var op = worldScripts.oreProcessor;
                // Idle
                var idle = !op._oreTimer.isRunning;
                // Processing: x remaining
                var sp = op._splinter.length;
                // Damaged
                var sts = p.equipmentStatus("EQ_ORE_PROCESSOR");
                if (sts != "EQUIPMENT_UNAVAILABLE" && sts != "EQUIPMENT_UNKNOWN") {
                    outputData = (sts == "EQUIPMENT_DAMAGED" ? "DAMAGED" : (idle ? "Idle: " : "Working: ") + sp + " remain");
                }
                break;
            case "RANK":
                outputLabel = "RANK";
                var rnk = player.rank;
                var score = player.score;
                if (score >= 6400) rnk = "★ ELITE ★";
                outputData = rnk + (score < 6400 ? " (->" + this.$killsUntilNextRank() + ")" : "") + ": " + (score - this._killsOnLaunch).toString();
                break;
            case "STATUS":
                outputLabel = "LEGAL";
                outputData = player.legalStatus + " (" + player.bounty + ")";
                break;
        }
        p.setCustomHUDDial(slotLabel, outputLabel);
        p.setCustomHUDDial(slotData, this.$padText(outputData, this._widths[slotData][this._widthLookup], true));
    }

    /*
     *     equip mode
     */

    var eq_mode = "";
    switch (p.primedEquipment) {
        case "EQ_MFD_FAST_CONFIG":
            var mfd = worldScripts.MFDFastConfiguration;
            if (mfd) {
                var modes = [
                    "Set current as set 1",
                    "Set current as set 2",
                    "Set current as set 3",
                    "Set current as Cond Green set",
                    "Set current as Cond Yellow set",
                    "Set current as Cond Red set",
                    "Set current as docking set",
                    "Make set 1 default",
                    "Make set 2 default",
                    "Make set 3 default",
                    "Make Cond Green set default",
                    "Make Cond Yellow set default",
                    "Make Cond Red set default",
                    "Delete set 1",
                    "Delete set 2",
                    "Delete set 3",
                    "Delete Cond Green set",
                    "Delete Cond Yellow set",
                    "Delete Cond Red set",
                    "Delete docking set",
                    "Hide setting functions from list",
                    "Activate default set",
                    "Activate set 1",
                    "Activate set 2",
                    "Activate set 3",
                    "Activate Cond Green set",
                    "Activate Cond Yellow set",
                    "Activate Cond Red set",
                    "Activate docking set",
                    "Disable auto-update mode",
                    "Restore setting functions to list"
                ];
                eq_mode = modes[mfd._curr_mode];
            }
            break;
        case "EQ_COMMSLOGMFD":
            var cl = worldScripts.CommsLogMFD;
            if (cl && (cl._currMode || cl._currMode == 0)) {
                switch (cl._currMode) {
                    case 0: eq_mode = "Scroll back mode";
                        break;
                    case 1: eq_mode = "Scroll forward mode";
                        break;
                    case 2: eq_mode = "Scroll to prev launch";
                        break;
                    case 3: eq_mode = "Scroll to next launch";
                        break;
                    case 4: eq_mode = "View current";
                        break;
                    case 5: eq_mode = "View oldest";
                        break;
                    case 6: eq_mode = "Clear log mode";
                        break;
                    case 7: eq_mode = "Write comms to log";
                        break;
                    case 8:
                        if (worldScripts.CommsLogMFD._scrollMethod === 0) {
                            eq_mode = "Set scroll by message";
                        } else {
                            eq_mode = "Set scroll by line";
                        }
                        break;
                    default: eq_mode = "Scroll back mode";
                        break;
                }
            }
            break;
        case "EQ_TARGET_FILTERING_SYSTEM":
            if (p.equipmentStatus("EQ_TARGET_FILTERING_SYSTEM") === "EQUIPMENT_OK") {
                switch (this._TFS._mode) {
                    case 0: eq_mode = "Hostile/outlaw";
                        break;
                    case 1: eq_mode = "Thargoid";
                        break;
                    case 2: eq_mode = "Police";
                        break;
                    case 3: eq_mode = "Neutral";
                        break;
                    case 4: eq_mode = "Cargo";
                        break;
                    case 5: eq_mode = "Asteroids";
                        break;
                }
            }
            break;
        case "EQ_WPH_ASC_UPGRADE":
            if (p.equipmentStatus("EQ_WPH_ASC_UPGRADE") === "EQUIPMENT_OK") {
                eq_mode = "Clear current waypoint";
            }
            break;
        case "EQ_FUEL_TRANSFER":
            if (p.equipmentStatus("EQ_FUEL_TRANSFER") === "EQUIPMENT_OK") {
                eq_mode = "Stop transfer";
            }
            break;
        case "EQ_BROADCASTCOMMSMFD":
            if (p.equipmentStatus("EQ_BROADCASTCOMMSMFD") === "EQUIPMENT_OK") {
                eq_mode = "Select next option";
            }
            break;
        case "EQ_MARKET_INQUIRER_MFD":
            if (p.equipmentStatus("EQ_MARKET_INQUIRER_MFD") == "EQUIPMENT_OK") {
                eq_mode = "View next commodity";
            }
            break;
        case "EQ_GCM_RANGE_FINDER_MFD":
            if (p.equipmentStatus("EQ_GCM_RANGE_FINDER_MFD") === "EQUIPMENT_OK") {
                switch (worldScripts.GalCopBB_RangeFinder_MFD._mode) {
                    case 0: eq_mode = "Escape capsules";
                        break;
                    case 1: eq_mode = "Black boxes";
                        break;
                    case 2: eq_mode = "Asteroids";
                        break;
                    case 3: eq_mode = "Ships";
                        break;
                    case 4: eq_mode = "Comm relays";
                        break;
                    case 5: eq_mode = "Cargo pods";
                        break;
                    default: eq_mode = "Escape capsules";
                        break;
                }
            }
            break;
        case "EQ_BULK_CARGO_PROCESSOR":
            if (p.equipmentStatus("EQ_BULK_CARGO_PROCESSOR") === "EQUIPMENT_OK") eq_mode = "Cycle processing type";
            break;
        case "EQ_FUEL_INJECTION_CRUISECONTROL":
            if (p.equipmentStatus("EQ_FUEL_INJECTION_CRUISECONTROL") === "EQUIPMENT_OK") {
                if (worldScripts.FuelInjectionCruiseControl._autoEngage) {
                    eq_mode = "Turn off auto-engage";
                } else {
                    eq_mode = "Turn on auto-engage";
                }
            }
            break;
        case "EQ_SHIPS_LIBRARY":
            if (p.equipmentStatus("EQ_SHIPS_LIBRARY") === "EQUIPMENT_OK") {
                eq_mode = expandDescription("[ships-library-mfd-mode" + worldScripts["Ships Library"].$mfdMode + "]");
            }
            break;
        case "EQ_MANIF_SCANNER":
            if (p.equipmentStatus("EQ_MANIF_SCANNER") === "EQUIPMENT_OK") {
                if (worldScripts.ManifestScanner._scanMode == 0) {
                    eq_mode = "Set active scan mode";
                } else {
                    eq_mode = "Set manual scan mode";
                }
            }
            break;
        case "EQ_HEAT_SINK_CONTROL":
            if (p.equipmentStatus("EQ_HEAT_SINK_CONTROL") === "EQUIPMENT_OK") {
                if (worldScripts.ShipConfiguration_HeatSink._mode == 0) {
                    eq_mode = "Set auto deploy mode";
                } else {
                    eq_mode = "Set manual deploy mode";
                }
            }
            break;
        case "EQ_SMUGGLING_INFLIGHT_STORAGE":
            if (p.equipmentStatus("EQ_SMUGGLING_INFLIGHT_STORAGE") === "EQUIPMENT_OK") {
                eq_mode = "Cycle cargo to store";
            }
            break;
        case "EQ_CAMERA_DRONES":
            if (p.equipmentStatus("EQ_CAMERA_DRONES") === "EQUIPMENT_OK") {
                eq_mode = "Select next camera";
            }
            break;
        case "EQ_WARRANT_SCANNER":
            var ws = worldScripts["BountySystem_WarrantScanner"];
            switch (ws._outputMode) {
                case 0: eq_mode = "MFD output";
                    break;
                case 1: eq_mode = "Console output";
            }
            break;
        case "EQ_HYPER_RADIO":
            eq_mode = "Reconnect";
            break;
        case "EQ_ORE_PROCESSOR":
            eq_mode = "Scan minerals";
            break;
        case "EQ_WPH_ASC_UPGRADE":
            eq_mode = "Delete selected";
            break;
        /*        case "EQ_TELESCOPE":    //.$Telescopeeq_MenuItem
                        var ws = worldScripts["telescope"];
                        var tm = ["Nearest target",
                                            "Rescan",
                                            "Step forward",
                                            "Step back",
                                            "Lightballs",
                                            "Sniper ring",
                                            "Steering",
                                            "Targets",
                                            "Visual target",
                                            "Visual target size"];
                        eq_mode = tm[ws.???];
                        break; */
        case "EQ_TOWBAR":
            if (p.equipmentStatus("EQ_TOWBAR") === "EQUIPMENT_OK") {
                var ws = worldScripts["towbar"];
                switch (ws.$TowbarMiner) {
                    case 0: eq_mode = "Offline";
                        break;
                    case 1: eq_mode = "Cargo only";
                        break;
                    case 2: eq_mode = "Up to full";
                        break;
                    case 3: eq_mode = "Salvager";
                        break;
                    default: eq_mode = "Miner N/A";
                }
            }
            break;
        default: eq_mode = "N/A";
    }
    p.setCustomHUDDial("VimanaX_EQMode", this.$padText(eq_mode, this._widths["VimanaX_EQMode"][this._widthLookup]));
}

/**************************************
 *                          right panel
 * ************************************/
//Player ship shields and hull test animation
//----------------------------------------------------------------------------------------
this.$animHull = function _vimanaXHUD_animHull() {
    var p = player.ship;
    if (!p || !p.isValid) return;
    if (!this._timer3Ping) { this._timer3Ping = true; this.$playSound(); }

    if (p.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") === "EQUIPMENT_OK") {
        if (this._hullAnim[0]) {
            if (this._hullAnim[1] > 10) this._hullAnim[1] = 1;
            else this._hullAnim[1]++;
            if (this._hullAnim[1] <= 4) p.setCustomHUDDial("VimanaX_HullAnim", "vx_scan_" + this._hullAnim[1] + ".png");
            else p.setCustomHUDDial("VimanaX_HullAnim", "vx_blank.png");
        }
        var wtp = Math.round(p.aftShield / p.maxAftShield * 100);
        var wtt = Math.round(p.forwardShield / p.maxForwardShield * 100);
        if (wtp > 75) p.setCustomHUDDial("VimanaX_TT", "vx_tt100.png");
        else if (wtp > 50 && wtp < 76) p.setCustomHUDDial("VimanaX_TT", "vx_tt75.png");
        else if (wtp > 25 && wtp < 51) p.setCustomHUDDial("VimanaX_TT", "vx_tt50.png");
        else if (wtp > 1 && wtp < 26) p.setCustomHUDDial("VimanaX_TT", "vx_tt25.png");
        else p.setCustomHUDDial("VimanaX_TT", "vx_blank.png");

        if (wtt > 75) p.setCustomHUDDial("VimanaX_TP", "vx_tp100.png");
        else if (wtt > 50 && wtt < 76) p.setCustomHUDDial("VimanaX_TP", "vx_tp75.png");
        else if (wtt > 25 && wtt < 51) p.setCustomHUDDial("VimanaX_TP", "vx_tp50.png");
        else if (wtt > 1 && wtt < 26) p.setCustomHUDDial("VimanaX_TP", "vx_tp25.png");
        else p.setCustomHUDDial("VimanaX_TP", "vx_blank.png");
    } else {
        p.setCustomHUDDial("VimanaX_HullAnim", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_TT", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_TP", "vx_blank.png");
        if (p.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") === "EQUIPMENT_UNAVAILABLE") {
            this.$AnimTimer.stop();
            delete this.$AnimTimer;
        }
    }
}

//----------------------------------------------------------------------------------------
this.$equipmentStatus = function _vimanaXHUD_equipmentStatus() {  //check equip             
    var p = player.ship;
    p.setCustomHUDDial("VimanaX_Rh1", "");
    p.setCustomHUDDial("VimanaX_Rh2", "");
    var i = 10;
    while (i--) {
        p.setCustomHUDDial("VimanaX_R" + i, "");
    }
    if (p.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") === "EQUIPMENT_OK") {
        p.setCustomHUDDial("VimanaX_PSName", this.$padText(p.displayName, this._widths["VimanaX_PSName"][this._widthLookup]));
        if (this._hullAnim[0]) var m = "vx_" + this._hullAnim[0] + ".png";
        else var m = "vx_blank.png";
        p.setCustomHUDDial("VimanaX_PShip", m);

        if (this._eqDamaged.length) {
            /***********************
             *         equip damaged
             * *********************/
            var pd = Math.round((this._eqDamaged.length / p.equipment.length) * 1000) / 10;
            p.setCustomHUDDial("VimanaX_Rh1", this._shipDamaged);
            p.setCustomHUDDial("VimanaX_Rh2", this._eqDamaged.length + " (" + pd + "%) system(s) broken");
            p.setCustomHUDDial("VimanaX_R0", this._checkList);

            if (this._SRS && this._SRS.$controllerVersion && missionVariables.repairCounter > 0) {
                if (this._SRS.$selfRepairsSystemStatus === "Stand-by")
                    this._SRS.checkEquipment();
            }
        } else {
            /***********************
             *         no damage
             * *********************/
            p.setCustomHUDDial("VimanaX_Rh1", "");
            p.setCustomHUDDial("VimanaX_Rh2", "");

            if (this._lastUsed[16] > 0) {
                p.setCustomHUDDial("VimanaX_R8", "All equipment & systems");
                p.setCustomHUDDial("VimanaX_R9", "operational and efficient");
            } else {
                p.setCustomHUDDial("VimanaX_R9", " No additional equipment!");
            }
        }
    } else {
        var tx = "UNAVAILABLE";
        p.setCustomHUDDial("VimanaX_R1", tx);
        if (p.equipmentStatus("EQ_VIMANAX_SHIP_MODULE") === "EQUIPMENT_DAMAGED") tx = "Module damaged";
        else tx = "Module not installed";
        p.setCustomHUDDial("VimanaX_R2", tx);
        p.setCustomHUDDial("VimanaX_PShip", "vx_blank.png");
    }
}

/**************************************
 *                            left panel
 * ************************************/
//----------------------------------------------------------------------------------------
this.$setLPanel = function _vimanaXHUD_setLPanel() {
    var p = player.ship;
    var i = 10;
    while (i--) {
        p.setCustomHUDDial("VimanaX_L" + i, "");
    }
    if (p.target && p.target.isValid && !p.target.isWormhole) {
        if (p.equipmentStatus("EQ_VIMANAX_TARGET_MODULE") === "EQUIPMENT_OK") {
            this.$targetInfo();
        } else {
            p.setCustomHUDDial("VimanaX_PTarget", "vx_blank.png");
            p.setCustomHUDDial("VimanaX_Lh", "");
            var tx = "";
            p.setCustomHUDDial("VimanaX_L3", "UNAVAILABLE"); // center?
            if (p.equipmentStatus("EQ_VIMANAX_TARGET_MODULE") === "EQUIPMENT_DAMAGED") tx = "Module damaged";
            else tx = "Module not installed";
            p.setCustomHUDDial("VimanaX_L4", tx); // center?
        }
    } else {                                 //travel info
        if (this._lastUsed[12] == 1) {
            this._lastUsed[12] == 0;
            this._lastUsed[13] = "";
            p.setCustomHUDDial("VimanaX_LPTitle", this._travelHeader);
            p.setCustomHUDDial("VimanaX_PTarget", "vx_globe.png");
            p.setCustomHUDDial("VimanaX_CEnergy", "");
            p.setCustomHUDDial("VimanaX_CSpeed", "");
            p.setCustomHUDDial("VimanaX_CMissile", "");

            if (p.equipmentStatus("EQ_VIMANAX_TRAVEL_MODULE") === "EQUIPMENT_OK") {
                this.$travelInfo();
            } else {
                this.$jumpDistIndicator();
                p.setCustomHUDDial("VimanaX_PTarget", "vx_blank.png");
                p.setCustomHUDDial("VimanaX_Lh", "");
                var tx = "";
                p.setCustomHUDDial("VimanaX_L3", "UNAVAILABLE"); // center?
                if (p.equipmentStatus("EQ_VIMANAX_TRAVEL_MODULE") === "EQUIPMENT_DAMAGED") tx = "Module damaged";
                else tx = "Module not installed";
                p.setCustomHUDDial("VimanaX_L4", tx); // center?
            }
        }
    }
}

//----------------------------------------------------------------------------------------
this.$targetInfo = function _vimanaXHUD_targetInfo() {
    var that = _vimanaXHUD_targetInfo;
    var _padText = (that._padText = that._padText || this.$padText);
    var _cbtMFD = (that._cbtMFD = that._cbtMFD || this._combatMFD);
    var _gameShips = (that._gameShips = that._gameShips || this._gameShips);
    var p = player.ship;

    var tdata = [];
    var col1 = 5;
    var max = 11.12;
    var hmax = 9.64;
    if (this._widthLookup == 1) { max = 13.35; col1 = 6; hmax = 11.86; }

    var i = 10;
    while (i--) {
        tdata[i] = "";
    }
    this._lastUsed[12] = 1;
    tdata[0] = p.target.displayName;

    if (p.target.dataKey == "telescopemarker") {
        tdata[1] = "Additional info not available";
        tdata[2] = "(Out of range)";
        var itn = tdata[0].indexOf("km ");
        if (itn > -1 && itn < 10) tdata[0] = tdata[0].substr(itn + 3);
        if (this._lastUsed[13] != tdata[0]) { //load target model only for telescope 
            this._lastUsed[13] = tdata[0];
            var m = null;
            var tn = _gameShips[tdata[0]];
            if (tn == "***") tn = null; // how to get data key of telescope target?
            if (tn) m = "vx_" + tn + ".png";
            if (m) var model = m; else var model = "vx_blank.png";
            p.setCustomHUDDial("VimanaX_PTarget", model);
        }
    } else if ((p.target.isBoulder || p.target.isRock) && !p.target.isPiloted) {
        tdata[1] = _padText("SPEED:", col1) + p.target.velocity.magnitude().toFixed(0) + "m/s";
        tdata[2] = _padText("BOUNTY:", col1) + p.target.bounty + "€";
    } else if (p.target.isMissile) {
        tdata[1] = _padText("SPEED:", col1) + p.target.velocity.magnitude().toFixed(0) + "m/s";
        tdata[2] = _padText("ENERGY:", col1) + Math.round(p.target.energy);
        tdata[4] = _padText("TRAVELED:", col1) + p.target.distanceTravelled.toFixed(0) + " m";
    } else if (p.target.scanClass == "CLASS_BUOY" && !p.target.isPiloted) {
        if (p.target.name) tdata[0] = p.target.name;
        else if (p.target.beaconLabel) tdata[0] = p.target.beaconLabel;
        else if (p.target.beaconCode) tdata[0] = p.target.beaconCode;
        else tdata[0] = "Unidentified";
        tdata[2] = _padText("ENERGY:", col1) + Math.round(p.target.energy);
        tdata[3] = _padText("RADIUS:", col1) + Math.round(p.target.collisionRadius) + " m";
    } else if (p.target.isStation) {
        tdata[3] = _padText("RADIUS:", col1) + Math.round(p.target.collisionRadius) + " m";
        tdata[4] = _padText("ENERGY:", col1) + Math.round(p.target.energy);
        tdata[6] = _padText("DEFENDERS:", col1) + p.target.dockedPolice;
        if (p.target.requiresDockingClearance) {
            tdata[1] = _padText("DOCK:", col1) + "REQUEST";
            switch (player.dockingClearanceStatus) {
                case "DOCKING_CLEARANCE_STATUS_REQUESTED":
                    tdata[1] = _padText("DOCK:", col1) + "HOLD";
                    break;
                case "DOCKING_CLEARANCE_STATUS_GRANTED":
                    tdata[1] = _padText("DOCK:", col1) + "GRANTED";
                    break;
                case "DOCKING_CLEARANCE_STATUS_TIMING_OUT":
                    tdata[1] = _padText("DOCK:", col1) + "EXPIRING";
            }
        } else {
            tdata[1] = _padText("DOCK:", col1) + "FREE";
        }
    } else if (p.target.isDerelict) {
        tdata[2] = _padText("ENERGY:", col1) + Math.round(p.target.energy);
        tdata[4] = _padText("CARGO:", col1) + p.target.cargoSpaceUsed + "/" + p.target.cargoSpaceCapacity + "t";
    } else if (p.target.isShip && (p.target.isPiloted || p.target.isThargoid)) {
        tdata[1] = _padText("SPEED:", col1) + p.target.velocity.magnitude().toFixed(0) + "m/s";
        tdata[2] = _padText("ENERGY:", col1) + Math.round(p.target.energy);
        // use combatMFD to get weapon type, so we don't get more information than it provides
        tdata[5] = _padText("WEAPON:", col1) + _padText(_cbtMFD.$Data["combatTLaser"].replace("Laser: ", ""), (max - col1));
        tdata[6] = _padText("RANGE:", col1) + (tdata[5].indexOf("Unknown") >= 0 ? "??" : (p.target.weaponRange / 1000).toFixed(1) + "km");
        var mc = 0;
        var hmc = 0;
        var msc = "";
        i = p.target.missiles.length;
        while (i--) {
            let mst = p.target.missiles[i].equipmentKey;
            if (mst == "EQ_MISSILE" || mst == "EQ_ARMOURY_STANDARD_MISSILE") mc++;
            else hmc++;
        }

        if (hmc > 0 && mc > 0) msc = hmc + "h/" + mc + "s";
        else if (hmc > 0) msc = hmc + "h";
        else if (mc > 0) msc = mc + "s";
        else msc = "0";
        tdata[4] = _padText("MISSILE:", col1) + msc;
        tdata[7] = _padText("CARGO:", col1) + p.target.cargoSpaceUsed + "/" + p.target.cargoSpaceCapacity + "t";
        tdata[9] = _padText("BOUNTY:", col1) + p.target.bounty + "€";
        if (player.alertCondition == 3) {
            p.setCustomHUDDial("VimanaX_CEnergy", "E: " + Math.round(p.target.energy));
            p.setCustomHUDDial("VimanaX_CSpeed", "V: " + p.target.velocity.magnitude().toFixed(0) + "m/s");
            p.setCustomHUDDial("VimanaX_CMissile", "M: " + msc);
        }
    } else if (p.target.isCargo) {
        tdata[0] = p.target.name;
        tdata[1] = p.target.shipUniqueName;
        if (tdata[1].indexOf("Gold") > -1 || tdata[1].indexOf("Platinum") > -1) var unit = "kg";
        else if (tdata[1].indexOf("Gem-Stones") > -1) var unit = "g";
        else var unit = "t";
        tdata[2] = _padText("AMOUNT:", col1) + p.target.commodityAmount + unit;
        tdata[3] = _padText("SPEED:", col1) + p.target.velocity.magnitude().toFixed(0) + "m/s";
    }
    //--------------
    p.setCustomHUDDial("VimanaX_Lh", this.$padText(tdata[0], hmax));
    p.setCustomHUDDial("VimanaX_L0", "");
    i = 9
    while (i--) {
        p.setCustomHUDDial("VimanaX_L" + (i + 1), tdata[i + 1]);
    }
}

//----------------------------------------------------------------------------------------
this.$travelInfo = function _vimanaXHUD_travelInfo() {
    var that = _vimanaXHUD_travelInfo;
    var _padText = (that._padText = that._padText || this.$padText);
    var p = player.ship;
    var dest = "Destination not set";

    this._reqFuel = 0;
    var ddist = "";
    var nlabel = "";

    var col1 = 7;
    var col2 = 1.8;
    var col3 = 6.2;
    var max = 11.12;
    var hmax = 9.64;
    if (this._widthLookup == 1) { max = 13.35; col1 = 9.0; col2 = 2.1; col3 = 7.3; hmax = 11.86; }

    var i = 7;
    while (i--) {
        p.setCustomHUDDial("VimanaX_L" + (i + 3), "");
    }
    if (system.isInterstellarSpace) {
        dest = "Interstellar Space!";
        ddist = "Route calculation unavailable";
        nlabel = "";
    } else if (system.ID != p.targetSystem) {
        var fullRoute = system.info.routeToSystem(System.infoForSystem(galaxyNumber, p.targetSystem), p.routeMode);
        var tsys = System.infoForSystem(galaxyNumber, p.targetSystem);
        dest = _padText(tsys.name, col1) + this._ecos[tsys.economy] + this._govs[tsys.government] + (tsys.techlevel + 1);
        let dday = Math.floor(fullRoute.time / 24);
        let dhour = Math.floor(fullRoute.time % 24);
        let dmin = Math.floor(fullRoute.time % 60);
        let tx = Math.floor(fullRoute.distance * 10) / 10;
        let hp = fullRoute.route.length - 1;
        ddist = tx.toFixed(1).toString() + "ly, " + dday + "d:" + dhour + "h:" + dmin + "m, " + hp + " jmp";
        if (defaultFont.measureString(ddist) > hmax) {
            ddist = tx.toFixed(1).toString() + "ly, " + fullRoute.time.toFixed(1) + "h, " + hp + " jmp";
        }
        if (fullRoute.route.length > 0) {
            if (fullRoute.route.length > 8) var nxr = 8;
            else var nxr = fullRoute.route.length;
            if (p.routeMode === "OPTIMIZED_BY_NONE" && fullRoute.route.length > 2) {
                p.setCustomHUDDial("VimanaX_L4", "Unknown route!");
            } else {
                for (i = 1; i < nxr; i++) {
                    let a = i + 2;
                    let b = System.infoForSystem(galaxyNumber, fullRoute.route[i]);
                    let c = system.info.routeToSystem(System.infoForSystem(galaxyNumber, fullRoute.route[i]), p.routeMode);
                    let tx = Math.floor(c.distance * 10) / 10;
                    if (i == 1) this._reqFuel = tx;
                    let d = _padText(tx.toFixed(1).toString(), col2, true) + "ly" + "  " + _padText(b.name, col3) + this._ecos[b.economy] + this._govs[b.government] + (b.techlevel + 1);
                    p.setCustomHUDDial("VimanaX_L" + a, d);
                }
            }
            nlabel = this._nextHops;
        }
    }
    p.setCustomHUDDial("VimanaX_Lh", dest);
    p.setCustomHUDDial("VimanaX_L0", ddist);
    p.setCustomHUDDial("VimanaX_L1", "");
    p.setCustomHUDDial("VimanaX_L2", nlabel);
}

//----------------------------------------------------------------------------------------
// used when travel mod hasn't been purchased or isn't available
this.$jumpDistIndicator = function _vimanaXHUD_jumpDistIndicator() {
    var p = player.ship;
    this._reqFuel = 0;
    if (!p || !p.isValid) return;
    var fullRoute = system.info.routeToSystem(System.infoForSystem(galaxyNumber, p.targetSystem), p.routeMode);
    let b = system.info;
    let c = system.info.routeToSystem(System.infoForSystem(galaxyNumber, fullRoute.route[1]), p.routeMode);
    let tx = Math.floor(c.distance * 10) / 10;
    this._reqFuel = tx;
}

//----------------------------------------------------------------------------------------
this.$checkMaint = function _vimanaXHUD_checkMaint() {
    var p = player.ship;
    if (p.serviceLevel < 85) {
        this._maintenance = true;
    } else {
        this._maintenance = false;
        p.setCustomHUDDial("VimanaX_Service", "vx_blank.png");
    }
}

/***********************************
 *                    indicators
 ***********************************/
//----------------------------------------------------------------------------------------
this.$showIndicators = function _vimanaXHUD_showIndicators() {
    var that = _vimanaXHUD_showIndicators;
    var _padText = (that._padText = that._padText || this.$padText);
    var _widths = (that._widths = that._widths || this._widths);
    var p = player.ship;
    if (!p || !p.isValid) return;
    var i = 0;
    var efl = 0 //extra fuel
    var speed = Math.round(p.velocity.magnitude() / 10) * 10;
    var ctemp = Math.round(p.temperature * 100);
    var fuel = (p.fuel).toFixed(1);
    var td = -1;

    if (p.target && p.target.isValid && !p.target.isWormhole) { //calculate & display distance to player target
        var trg = p.target;
        if (p.target.dataKey == "telescopemarker")
            if (this._TLS.$TelescopeList[this._TLS.$TelescopeListi - 1]) trg = this._TLS.$TelescopeList[this._TLS.$TelescopeListi - 1];
        if (trg.position) {
            td = trg.position.distanceTo(p.position) - Math.round(trg.collisionRadius);
            if (td > 100000) td = Math.round(td / 1000);
            else td = Math.round(td / 10) / 100;
        }
    } else {
        var sec = "" + Math.floor(clock.seconds % 60); //display clock
        if (sec.length < 2) sec = "0" + sec;
        var min = "" + Math.floor(clock.minutes % 60);
        if (min.length < 2) min = "0" + min;
        p.setCustomHUDDial("VimanaX_SClock", Math.floor(clock.hours % 24) + ":" + min + ":" + sec + " - " + clock.days);
    }
    p.setCustomHUDDial("VimanaX_TDist", (td != -1 ? td.toFixed(2) : "* * * ") + this._spacer);
    //DuplexFuelTank.oxz
    if (p.equipmentStatus("EQ_DUPLEX_FUEL_TANK_STATE_1") == "EQUIPMENT_OK") efl += 1;
    else if (p.equipmentStatus("EQ_DUPLEX_FUEL_TANK_STATE_2") == "EQUIPMENT_OK") efl += 2;
    else if (p.equipmentStatus("EQ_DUPLEX_FUEL_TANK_STATE_3") == "EQUIPMENT_OK") efl += 3;
    //ExtraFuelTanks
    if (p.equipmentStatus("EQ_RESERVE_TANK") == "EQUIPMENT_OK") efl += 1;
    else if (p.equipmentStatus("EQ_AUX_TANK") == "EQUIPMENT_OK") efl += 3;
    //Fuel_Tank
    if (p.equipmentStatus("EQ_FUELTANK_MINE") == "EQUIPMENT_OK") {
        i = p.missiles.length;
        while (i--) {
            if (p.missiles[i].equipmentKey == "EQ_FUELTANK_MINE") efl += 3;
        }
    }
    // altitude calculation
    if (system.isInterstellarSpace) {
        var alt = 99999;
        this.$setGauge("VimanaX_AltG", alt, 50000, 11, "lp");
        p.setCustomHUDDial("VimanaX_Alt", "");
    } else {
        var ss = system.sun;
        if (ss) var d = p.position.distanceTo(ss.position);
        else var d = 100000000000000000000.0;

        var sp = system.planets;
        i = sp.length;
        while (i--) { //find the smallest distance
            var s = p.position.distanceTo(sp[i].position) - sp[i].radius;
            if (d > s) {
                d = s;
                ss = sp[i];
            }
        }
        var u = "";
        var alt = p.position.distanceTo(ss) - ss.radius - p.collisionRadius;
        if (this._lastUsed[11] != alt) {
            if (alt < 1000) {
                u = "0.";
                var a = alt;
            } else {
                var a = Math.round(alt / 1000);
            }
            this.$setGauge("VimanaX_AltG", alt, 50000, 11, "lp");
            p.setCustomHUDDial("VimanaX_Alt", u + Math.round(a));
        }
    }

    if (this._lastUsed[0] != ctemp) {     //cabin temperature
        p.setCustomHUDDial("VimanaX_CTemp", ctemp + "°");
        this.$setGauge("VimanaX_CTempG", ctemp, 100, 0, "ln");
    }
    if (this._lastUsed[1] != speed) {     //speed
        p.setCustomHUDDial("VimanaX_Speed", speed);
        if (speed > p.maxSpeed) this.$setGauge("VimanaX_SpeedG", speed, p.maxSpeed, 1, "ln");
        else this.$setGauge("VimanaX_SpeedG", speed, p.maxSpeed, 1, "lp");
    }
    if (this._lastUsed[2] != fuel || this._lastUsed[3] != efl) { //fuel
        var ef = "";
        if (efl) ef = "+" + Math.round(efl);
        p.setCustomHUDDial("VimanaX_Fuel", fuel + ef);
        this.$setGauge("VimanaX_FuelG", fuel, 7, 2, "lp");
        this._lastUsed[3] = efl;
        this._lastUsed[2] = fuel;
    }
    if (this._lastUsed[15] != this._reqFuel) {     //required fuel 
        var a = Math.round(this._reqFuel / (7 / 15));
        player.ship.setCustomHUDDial("VimanaX_FuelR", "vx_fr" + a + ".png");
        this._lastUsed[15] = this._reqFuel;
    }
    if (this._lastUsed[4] != p.cargoSpaceUsed || this._lastUsed[5] != p.cargoSpaceCapacity) {     //cargo
        p.setCustomHUDDial("VimanaX_Cargo", p.cargoSpaceUsed + "/" + p.cargoSpaceCapacity);
        this._lastUsed[5] = p.cargoSpaceCapacity;
        if (p.cargoSpaceCapacity == 0) this.$setGauge("VimanaX_CargoG", 1, 1, 4, "ln");
        else this.$setGauge("VimanaX_CargoG", p.cargoSpaceUsed, p.cargoSpaceCapacity, 4, "ln");
    }
    if (this._lastUsed[6] != p.energy) {        //energy
        p.setCustomHUDDial("VimanaX_Energy", Math.round(p.energy));
        this.$setGauge("VimanaX_EnergyG", p.energy, p.maxEnergy, 6, "pp");
        this._lastUsed[6] = p.energy;
    }
    if (this._lastUsed[7] != p.aftShield) {
        var wtp = Math.round(p.aftShield / p.maxAftShield * 100);
        p.setCustomHUDDial("VimanaX_Ash", wtp + "%");
        this.$setGauge("VimanaX_AshG", p.aftShield, p.maxAftShield, 7, "pp");
        this._lastUsed[7] = p.aftShield;
    }
    if (this._lastUsed[8] != p.forwardShield) {
        var wtt = Math.round(p.forwardShield / p.maxForwardShield * 100);
        p.setCustomHUDDial("VimanaX_Fsh", wtt + "%");
        this.$setGauge("VimanaX_FshG", p.forwardShield, p.maxForwardShield, 8, "pp");
        this._lastUsed[8] = p.forwardShield;
    }
    var lsname = p.currentWeapon.name;
    p.setCustomHUDDial("VimanaX_LaserName", _padText(lsname, _widths["VimanaX_LaserName"][this._widthLookup], true));

    if (this._lastUsed[9] != p.laserHeatLevel) {
        p.setCustomHUDDial("VimanaX_LaserTemp", Math.round(p.laserHeatLevel * 1190) + "°");
        this.$setGauge("VimanaX_LaserTempG", p.laserHeatLevel, 0.85, 9, "pn");
        this._lastUsed[9] = p.laserHeatLevel;
    }
    if ((p.equipmentStatus("EQ_IRONHIDE") == "EQUIPMENT_UNAVAILABLE" || p.equipmentStatus("EQ_IRONHIDE") == "EQUIPMENT_UNKNOWN") && !this._SC_Armour) {
        p.setCustomHUDDial("VimanaX_FArmour", "");
        p.setCustomHUDDial("VimanaX_FArmourG", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_FArmourLabel", "");
        p.setCustomHUDDial("VimanaX_AArmour", "");
        p.setCustomHUDDial("VimanaX_AArmourG", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_AArmourLabel", "");
    }
    if (this._lastUsed[10] != missionVariables.ironHide_percentage) {
        p.setCustomHUDDial("VimanaX_FArmour", missionVariables.ironHide_percentage + "%");
        this.$setGauge("VimanaX_FArmourG", missionVariables.ironHide_percentage, 100, 10, "pp");
        p.setCustomHUDDial("VimanaX_FArmourLabel", "ARMOUR");
        p.setCustomHUDDial("VimanaX_AArmour", "");
        p.setCustomHUDDial("VimanaX_AArmourG", "vx_blank.png");
        p.setCustomHUDDial("VimanaX_AArmourLabel", "");
        this._lastUsed[10] = missionVariables.ironHide_percentage;
    }
    if (this._SC_Armour) {
        var armourFront = 0;
        var armourAft = 0;
        var arm = worldScripts.ShipConfiguration_Armour;
        if (p.script._armourFront >= 0) {
            armourFront = p.script._armourFront;
            armourAft = p.script._armourAft;
        } else {
            armourFront = arm._armourFront;
            armourAft = arm._armourAft;
        }
        if (this._lastUsed[17] != armourFront) {
            p.setCustomHUDDial("VimanaX_FArmour", armourFront + "%");
            this.$setGauge("VimanaX_FArmourG", armourFront, 100, 17, "pp");
            p.setCustomHUDDial("VimanaX_FArmourLabel", "F.ARM");
            this._lastUsed[17] = armourFront;
        }
        if (this._lastUsed[18] != armourAft) {
            p.setCustomHUDDial("VimanaX_AArmour", armourAft + "%");
            this.$setGauge("VimanaX_AArmourG", armourAft, 100, 18, "pp");
            p.setCustomHUDDial("VimanaX_AArmourLabel", "A.ARM");
            this._lastUsed[18] = armourAft;
        }
    }
}

//----------------------------------------------------------------------------------------
this.$setGauge = function _vimanaXHUD_setGauge(key, cur, max, i, pos) {
    //set gauge speed, ctemp, alt, shield, etc
    var a = max / 15;
    this._lastUsed[i] = cur;
    if (cur > max) cur = max;
    a = Math.round(cur / a);
    player.ship.setCustomHUDDial(key, "vx_" + a + "_" + pos + ".png");
}

/***********************************
 *                    F4 interface
 ***********************************/
//-------------------------------------------------------------------------------------------------------------
this.$initInterface = function $initInterface(station) {
    station.setInterface(this.name, {
        title: "Vimana-X HUD Settings",
        category: "Ship Systems",
        summary: "Manages settings for some of the Vimana-X HUD components.",
        callback: this.$showPage.bind(this)
    });
}

//-------------------------------------------------------------------------------------------------------------
this.$showPage = function $showPage() {
    var curChoices = {};
    var text = "";
    var col = 22;
    var counter = 0;

    text = "Select from the options below:";

    curChoices["00_00_ALERTS"] = {
        text: "Large alert popups on the main screen - " + (worldScripts.VimanaX_Alerts._disabled == false ? "Enabled" : "Disabled"),
        color: "greenColor",
        alignment: "LEFT",
        unselectable: true
    };
    if (worldScripts.VimanaX_Alerts._disabled == false) {
        curChoices["00_00_DISABLE_ALERTS"] = {
            text: "- Disable large alert popups",
            alignment: "LEFT"
        };
    } else {
        curChoices["00_00_ENABLE_ALERTS"] = {
            text: "- Enable large alert popups",
            alignment: "LEFT"
        };
    }
    curChoices["00_01_STYLE"] = {
        text: "Main screen UI style - " + this._style,
        color: "greenColor",
        alignment: "LEFT",
        unselectable: true
    };
    if (this._style == "dark") {
        curChoices["00_01_UILIGHT"] = {
            text: "- Change style to light",
            alignment: "LEFT"
        };
    } else {
        curChoices["00_01_UIDARK"] = {
            text: "- Change style to dark (helps manage glare)",
            alignment: "LEFT"
        };
    }
    curChoices["00_02_HEADER"] = {
        text: "Non-linear scanner - " + (this._nonLinear ? "Yes" : "No") + " / Scanner ultra-zoom - " + (this._ultraZoom ? "Yes" : "No"),
        color: "greenColor",
        alignment: "LEFT",
        unselectable: true
    };
    if (this._nonLinear == true) {
        curChoices["00_02_LINEAR"] = {
            text: "- Switch to linear scanner (ships can diseappear from zoomed scanner)",
            alignment: "LEFT"
        }
    } else {
        curChoices["00_02_NONLINEAR"] = {
            text: "- Switch to non-linear scanner (ships are pushed outwards as zoom increases)",
            alignment: "LEFT"
        }
    }
    if (this._ultraZoom == true) {
        curChoices["00_03_NORMALZOOM"] = {
            text: "- Switch to normal zoom modes (1x/2x/3x/4x/5x)",
            alignment: "LEFT"
        }
    } else {
        curChoices["00_03_ULTRAZOOM"] = {
            text: "- Switch to ultra zoom modes (1x/2x/4x/8x/16x)",
            alignment: "LEFT"
        }
    }
    curChoices["00_99_OPTION"] = {
        text: "",
        unselectable: true
    };

    curChoices["01_00_HEADER"] = {
        text: "Special Slot 1 content",
        alignment: "LEFT",
        color: "greenColor",
        unselectable: true
    };
    curChoices["02_00_HEADER"] = {
        text: "Special Slot 2 content",
        alignment: "LEFT",
        color: "greenColor",
        unselectable: true
    };
    curChoices["01_00_OPTION"] = {
        text: this.$padText("- Nothing", col) + (this._setSlot1 == 0 ? " ** currently set" : ""),
        alignment: "LEFT"
    };
    curChoices["02_00_OPTION"] = {
        text: this.$padText("- Nothing", col) + (this._setSlot2 == 0 ? " ** currently set" : ""),
        alignment: "LEFT"
    };
    if (this._AMS) {
        counter += 1;
        curChoices["01_01_OPTION"] = {
            text: this.$padText("- Anti-Missile system (when installed)", col) + (this._setSlot1 == 1 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
        curChoices["02_01_OPTION"] = {
            text: this.$padText("- Anti-Missile system (when installed)", col) + (this._setSlot2 == 1 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
    }
    if (this._SRS) {
        counter += 1;
        curChoices["01_02_OPTION"] = {
            text: this.$padText("- Self-Repair system (when installed)", col) + (this._setSlot1 == 2 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
        curChoices["02_02_OPTION"] = {
            text: this.$padText("- Self-Repair system (when installed)", col) + (this._setSlot2 == 2 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
    }
    if (worldScripts.ShipConfiguration_HeatSink) {
        counter += 1;
        curChoices["01_05_OPTION"] = {
            text: this.$padText("- Heak sink control (when installed)", col) + (this._setSlot1 == 5 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
        curChoices["02_05_OPTION"] = {
            text: this.$padText("- Heak sink control (when installed)", col) + (this._setSlot2 == 5 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
    }
    if (worldScripts.oreProcessor) {
        counter += 1;
        curChoices["01_06_OPTION"] = {
            text: this.$padText("- Ore processor status (when installed)", col) + (this._setSlot1 == 6 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
        curChoices["02_06_OPTION"] = {
            text: this.$padText("- Ore processor status (when installed)", col) + (this._setSlot2 == 6 ? " ** currently set" : ""),
            alignment: "LEFT"
        };
    }
    curChoices["01_03_OPTION"] = {
        text: this.$padText("- Rank (with # kills for next rank and since launch)", col) + (this._setSlot1 == 3 ? " ** currently set" : ""),
        alignment: "LEFT"
    };
    curChoices["02_03_OPTION"] = {
        text: this.$padText("- Rank (with # kills for next rank and since launch)", col) + (this._setSlot2 == 3 ? " ** currently set" : ""),
        alignment: "LEFT"
    };
    curChoices["01_04_OPTION"] = {
        text: this.$padText("- Legal status (with current bounty)", col) + (this._setSlot1 == 4 ? " ** currently set" : ""),
        alignment: "LEFT"
    };
    curChoices["02_04_OPTION"] = {
        text: this.$padText("- Legal status (with current bounty)", col) + (this._setSlot2 == 4 ? " ** currently set" : ""),
        alignment: "LEFT"
    };

    for (var i = 0; i < (5 - counter); i++) {
        curChoices["98_SPACER_" + i.toString()] = {
            text: "",
            unselectable: true
        }
    }

    curChoices["99_EXIT"] = "Exit";
    if (this._default == "") this._default = "99_EXIT";

    var opts = {
        screenID: "oolite-vimanaxhud-dockside-map",
        title: "Vimana-X HUD Configuration",
        allowInterrupt: true,
        exitScreen: "GUI_SCREEN_INTERFACES",
        initialChoicesKey: this._default,
        choices: curChoices,
        message: text
    };
    mission.runScreen(opts, this.$screenHandler, this);
}

//-------------------------------------------------------------------------------------------------------------
this.$screenHandler = function $screenHandler(choice) {
    if (choice == null) return;

    this._default = choice;
    switch (choice) {
        case "00_00_DISABLE_ALERTS": worldScripts.VimanaX_Alerts._disabled = true; this._default = "00_00_ENABLE_ALERTS"; break;
        case "00_00_ENABLE_ALERTS": worldScripts.VimanaX_Alerts._disabled = false; this._default = "00_00_DISABLE_ALERTS"; break;
        case "00_01_UILIGHT": this._style = "light"; this._default = "00_01_UIDARK"; break;
        case "00_01_UIDARK": this._style = "dark"; this._default = "00_01_UILIGHT"; break;
        case "00_02_NONLINEAR": this._nonLinear = true; this._default = "00_02_LINEAR"; this.$updateHUDSelectorSettings(); break;
        case "00_02_LINEAR": this._nonLinear = false; this._default = "00_02_NONLINEAR"; this.$updateHUDSelectorSettings(); break;
        case "00_03_ULTRAZOOM": this._ultraZoom = true; this._default = "00_03_NORMALZOOM"; this.$updateHUDSelectorSettings(); break;
        case "00_03_NORMALZOOM": this._ultraZoom = false; this._default = "00_03_ULTRAZOOM"; this.$updateHUDSelectorSettings(); break;
        case "01_00_OPTION": this._setSlot1 = 0; this.$changeSettings(); break;
        case "01_01_OPTION": this._setSlot1 = 1; this.$changeSettings(); break;
        case "01_02_OPTION": this._setSlot1 = 2; this.$changeSettings(); break;
        case "01_03_OPTION": this._setSlot1 = 3; this.$changeSettings(); break;
        case "01_04_OPTION": this._setSlot1 = 4; this.$changeSettings(); break;
        case "01_05_OPTION": this._setSlot1 = 5; this.$changeSettings(); break;
        case "01_06_OPTION": this._setSlot1 = 6; this.$changeSettings(); break;
        case "02_00_OPTION": this._setSlot2 = 0; this.$changeSettings(); break;
        case "02_01_OPTION": this._setSlot2 = 1; this.$changeSettings(); break;
        case "02_02_OPTION": this._setSlot2 = 2; this.$changeSettings(); break;
        case "02_03_OPTION": this._setSlot2 = 3; this.$changeSettings(); break;
        case "02_04_OPTION": this._setSlot2 = 4; this.$changeSettings(); break;
        case "02_05_OPTION": this._setSlot2 = 5; this.$changeSettings(); break;
        case "02_06_OPTION": this._setSlot2 = 6; this.$changeSettings(); break;
    }

    if (choice != "99_EXIT") {
        this.$showPage();
    }
}

//----------------------------------------------------------------------------------------
this.$updateHUDSelectorSettings = function _cimanaXHUD_updateHUDSelectorSettings() {
    var h = worldScripts.hudselector;
    h.$HUDSelectorScanner = ((this._nonLinear ? 1 : 0) + (this._ultraZoom ? 2 : 0));
}

/***********************************
 *                    helpers
 ***********************************/
//----------------------------------------------------------------------------------------
this.$measureText = function _vimanaXHUD_measureText() {
    var test = defaultFont.measureString("0Z");
    var i = oolite.resourcePaths.length;
    while (i--) {
        // we're going to force the issue for OCRA Extended...
        if (oolite.resourcePaths[i].indexOf("OCRAExtended") >= 0) { test = 0.9; break; }
    }
    if (test > 0.864) this._widthLookup = 1;

    test = defaultFont.measureString("0");
    if (test > 0.5) {
        this._spacer = "";
    } else if (test > 0.45 && test <= 0.5) {
        this._spacer = " ";
    } else {
        this._spacer = "  ";
    }
}

//-------------------------------------------------------------------------------------------------------------
// appends space to currentText to the specified length in 'em'
this.$padText = function _vimanaXHUD_padText(currentText, desiredLength, leftSwitch, centreSwitch) {
    if (currentText == null) currentText = "";
    var hairSpace = String.fromCharCode(31);
    var ellip = "…";
    var currentLength = defaultFont.measureString(currentText.replace(/%%/g, "%"));
    var hairSpaceLength = defaultFont.measureString(hairSpace);
    // calculate number needed to fill remaining length
    var padsNeeded = Math.floor((desiredLength - currentLength) / hairSpaceLength);
    if (padsNeeded < 1) {
        // text is too long for column, so start pulling characters off
        var tmp = currentText;
        do {
            tmp = tmp.substring(0, tmp.length - 2) + ellip;
            if (tmp === ellip) break;
        } while (defaultFont.measureString(tmp.replace(/%%/g, "%")) > desiredLength);
        currentLength = defaultFont.measureString(tmp.replace(/%%/g, "%"));
        padsNeeded = Math.floor((desiredLength - currentLength) / hairSpaceLength);
        currentText = tmp;
    }
    // quick way of generating a repeated string of that number
    if (!leftSwitch || leftSwitch === false) {
        if (!centreSwitch || centreSwitch === false) {
            return currentText + new Array(padsNeeded).join(hairSpace);
        } else {
            return currentText + new Array(parseInt(padsNeeded / 2)).join(hairSpace);
        }
    } else {
        if (!centreSwitch || centreSwitch === false) {
            return new Array(padsNeeded).join(hairSpace) + currentText;
        } else {
            return new Array(parseInt(padsNeeded / 2)).join(hairSpace) + currentText;
        }
    }
}

//-------------------------------------------------------------------------------------------------------------
this.$changeSettings = function _vimanaXHUD_changeSettings() {
    var list = ["", "AMS", "SRS", "RANK", "STATUS", "HEATSINK", "OREPROC"];
    if (this._setSlot1 >= 0) this._specialSlots[0] = list[this._setSlot1];
    if (this._setSlot2 >= 0) this._specialSlots[1] = list[this._setSlot2];
}

//-------------------------------------------------------------------------------------------------------------
this.$updateShipConfigHUD = function $updateShipConfigHUD() {
    // tell ShipConfig to use our HUD on the F3 Equip Ship screen
    var sch = worldScripts.ShipConfiguration_F3HUDControl;
    var p = player.ship;
    if (sch && p.hud.indexOf(this.name) >= 0) {
        if (!sch._holdHUD) sch._holdHUD = sch._equipSpaceHUD;
        sch._equipSpaceHUD = this.name + "_docked.plist";
    }
}

//-------------------------------------------------------------------------------------------------------------
this.$revertShipConfigHUD = function $revertShipConfigHUD() {
    // tell ShipConfig to go back to it's former HUD on the F3 Equip Ship screen
    var sch = worldScripts.ShipConfiguration_F3HUDControl;
    var p = player.ship;
    if (sch && sch._holdHUD) {
        sch._equipSpaceHUD = sch._holdHUD;
        delete sch._holdHUD;
    }
}

//-------------------------------------------------------------------------------------------------------------
this.$killsUntilNextRank = function () {
    var ranks = [6400, 2560, 512, 128, 64, 32, 16, 8];
    var i = ranks.length;
    var score = player.score;
    while (i--) {
        if (ranks[i] > score) return (ranks[i] - score);
    }
    return 0;
}

//-------------------------------------------------------------------------------------------------------------
this.$playSound = function $playSound() {
    var mySound = new SoundSource();
    mySound.sound = "[@click]";
    mySound.loop = false;
    mySound.play();
}

// These functions are not used during gameplay. They are used to assist with creating the small ship images for
// the left and right panels
//-------------------------------------------------------------------------------------------------------------
this.$createShipImages = function (all) {
    var shipkeys = Ship.keys();
    this._list = [];
    this._types = [];
    if (!all) {
        this._list = this._sampleList.concat();
    } else {
        for (var i = 0; i < shipkeys.length; i++) {
            var shp = Ship.shipDataForKey(shipkeys[i]);
            if (shp.name !== undefined && !this._gameShips[shp.name] && this._types.indexOf(shp.name) == -1 &&
                shp.name != "Splinter" && shp.name != "Wreckage" && shp.name != "Machinery" && shp.name.indexOf("lib_ms") == -1 && !shp._oo_is_subentity &&
                shp.name.indexOf("Burning") == -1 && shp.name != "Sahana" && shipkeys[i].indexOf("towbar") == -1 &&
                shp.name.indexOf("dock") == -1 && shp.name.indexOf("Dock") == -1 && shipkeys[i].indexOf("jaguar") == -1 &&
                shipkeys[i].indexOf("billboard") == -1 && shipkeys[i].indexOf("laveAcademy") == -1 &&
                shp.name.indexOf("Card") == -1 && shp.name.indexOf("Turret") == -1 && shp.name.indexOf("Cargo") == -1 &&
                shp.name != "Question Mark") {
                this._list.push(shipkeys[i]);
                //log(this.name, shipkeys[i] + " -- " + shp.name);
            }
        }
    }
    //this._list = Ship.keysForRole("station");
    this._index = -1;
    var w = worldScripts.XenonUI;
    if (w) w.$addMissionScreenException("vimanax-ship");
    this.$showShip();
}

this.$showShip = function () {

    var found = false;
    var shp = null;
    do {
        this._index += 1;
        if (this._index >= this._list.length) return;
        log(this.name, "trying " + this._list[this._index] + "...");
        shp = Ship.shipDataForKey(this._list[this._index]);
        if (shp && shp.name) {
            if (this._types.indexOf(shp.name) == -1) found = true;
        } else {
            log(this.name, "WARNING: shp is " + (!shp ? "null" : "weird"));
            found = false;
        }
    } while (found == false);

    this._types.push(shp.name);
    log(this.name, this._list[this._index] + " -- " + shp.name);
    mission.runScreen({ screenID: "vimanax-ship", model: "[" + this._list[this._index] + "]", spinModel: false, background: "vx_white.png" });
    var m = mission.displayModel;
    if (shp.is_carrier && m) {
        m.position = Vector3D(0, 0, m.collisionRadius * 2.8);
        m.orientation = m.orientation.rotateX(1.6);
    }
    if (m && m.flashers && m.flashers.length > 0) {
        for (var i = m.flashers.length - 1; i >= 0; i--) {
            var fl = m.flashers[i];
            if (fl) fl.remove();
        }
    }
    this._timer = new Timer(this, this.$nextShip, 2, 0);
}

this.$nextShip = function (choice, keyPress) {
    this._timer.stop();
    takeSnapShot("vx_ship_" + this._list[this._index]);
    this.$showShip();
}
